/* ./irtmath.c :  entry=irtmath */
/* compiled by EusLisp 9.27() for Linux64 created on ip-172-30-1-171(Tue Aug 11 18:15:04 UTC 2020) */
#include "eus.h"
#include "irtmath.h"
#pragma init (register_irtmath)
extern double fabs();
extern pointer fcallx();
static void init_ftab();
extern pointer loadglobal(),storeglobal();
static pointer module,*qv,codevec,quotevec;
extern pointer ___irtmath();
extern pointer build_quote_vector();
static int register_irtmath()
  { add_module_initializer("___irtmath", ___irtmath);}

static pointer F69inverse_matrix();
static pointer F70inverse_matrix_complex();
static pointer F71m__complex();
static pointer F72diagonal();
static pointer F73minor_matrix();
static pointer F74atan2();
static pointer F75outer_product_matrix();
static pointer F76matrix2quaternion();
static pointer F77quaternion2matrix();
static pointer F78matrix_log();
static pointer F79matrix_exponent();
static pointer F80midrot();
static pointer F81pseudo_inverse();
static pointer F82pseudo_inverse_org();
static pointer F83sr_inverse();
static pointer F84sr_inverse_org();
static pointer F85manipulability();
static pointer F86random_gauss();
static pointer F87gaussian_random();
static pointer F88eigen_decompose();
static pointer F89eigen_decompose_complex();
static pointer F90solve_non_zero_vector_from_det0_matrix();
static pointer F91lms();
static pointer F92lms_estimate();
static pointer F93lms_error();
static pointer F94lmeds();
static pointer F95lmeds_error();
static pointer F96lmeds_error_mat();
static pointer F97concatenate_matrix_column();
static pointer F98concatenate_matrix_row();
static pointer F99concatenate_matrix_diagonal();
static pointer F100vector_variance();
static pointer F101covariance_matrix();
static pointer F102normalize_vector();

/*inverse-matrix*/
static pointer F69inverse_matrix(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	local[0]= argv[0];
	local[1]= makeint((eusinteger_t)0L);
	ctx->vsp=local+2;
	w=(*ftab[0])(ctx,2,local+0,&ftab[0],fqv[0]); /*array-dimension*/
	local[0]= w;
	local[1]= local[0];
	ctx->vsp=local+2;
	w=(*ftab[1])(ctx,1,local+1,&ftab[1],fqv[1]); /*unit-matrix*/
	local[1]= w;
	local[2]= argv[0];
	local[3]= local[1];
	ctx->vsp=local+4;
	w=(*ftab[2])(ctx,2,local+2,&ftab[2],fqv[2]); /*lu-decompose2*/
	local[2]= w;
	local[3]= NIL;
	local[4]= local[0];
	local[5]= local[0];
	ctx->vsp=local+6;
	w=(*ftab[3])(ctx,2,local+4,&ftab[3],fqv[3]); /*make-matrix*/
	local[4]= w;
	local[5]= loadglobal(fqv[4]);
	local[6]= local[0];
	ctx->vsp=local+7;
	w=(pointer)INSTANTIATE(ctx,2,local+5); /*instantiate*/
	local[5]= w;
	local[6]= makeint((eusinteger_t)0L);
	if (local[2]!=NIL) goto IF104;
	local[7]= fqv[5];
	ctx->vsp=local+8;
	w=(*ftab[4])(ctx,1,local+7,&ftab[4],fqv[6]); /*warn*/
	w = local[1];
	ctx->vsp=local+7;
	local[0]=w;
	goto BLK103;
	goto IF105;
IF104:
	local[7]= NIL;
IF105:
	local[7]= makeint((eusinteger_t)0L);
	local[8]= local[0];
WHL107:
	local[9]= local[7];
	w = local[8];
	if ((eusinteger_t)local[9] >= (eusinteger_t)w) goto WHX108;
	local[9]= argv[0];
	local[10]= local[1];
	ctx->vsp=local+11;
	w=(*ftab[2])(ctx,2,local+9,&ftab[2],fqv[2]); /*lu-decompose2*/
	local[2] = w;
	local[9]= local[5];
	local[10]= local[7];
	local[11]= makeflt(1.0000000000000000000000e+00);
	ctx->vsp=local+12;
	w=(pointer)ASET(ctx,3,local+9); /*aset*/
	local[9]= local[1];
	local[10]= local[2];
	local[11]= local[5];
	ctx->vsp=local+12;
	w=(*ftab[5])(ctx,3,local+9,&ftab[5],fqv[7]); /*lu-solve2*/
	local[3] = w;
	local[9]= makeint((eusinteger_t)0L);
	local[10]= local[0];
WHL111:
	local[11]= local[9];
	w = local[10];
	if ((eusinteger_t)local[11] >= (eusinteger_t)w) goto WHX112;
	local[11]= local[4];
	local[12]= local[9];
	local[13]= local[7];
	local[14]= local[3];
	local[15]= local[9];
	ctx->vsp=local+16;
	w=(pointer)AREF(ctx,2,local+14); /*aref*/
	local[14]= w;
	ctx->vsp=local+15;
	w=(pointer)ASET(ctx,4,local+11); /*aset*/
	local[11]= local[9];
	ctx->vsp=local+12;
	w=(pointer)ADD1(ctx,1,local+11); /*1+*/
	local[9] = w;
	goto WHL111;
WHX112:
	local[11]= NIL;
BLK113:
	w = NIL;
	local[9]= local[5];
	local[10]= local[7];
	local[11]= makeflt(0.0000000000000000000000e+00);
	ctx->vsp=local+12;
	w=(pointer)ASET(ctx,3,local+9); /*aset*/
	local[9]= local[7];
	ctx->vsp=local+10;
	w=(pointer)ADD1(ctx,1,local+9); /*1+*/
	local[7] = w;
	goto WHL107;
WHX108:
	local[9]= NIL;
BLK109:
	w = NIL;
	w = local[4];
	local[0]= w;
BLK103:
	ctx->vsp=local; return(local[0]);}

/*inverse-matrix-complex*/
static pointer F70inverse_matrix_complex(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	w=argv[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[0]= (w)->c.cons.car;
	w=argv[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	w=(w)->c.cons.cdr;
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[1]= (w)->c.cons.car;
	local[2]= NIL;
	local[3]= NIL;
	local[4]= NIL;
	local[5]= NIL;
	local[6]= local[0];
	ctx->vsp=local+7;
	w=(*ftab[6])(ctx,1,local+6,&ftab[6],fqv[8]); /*array-dimensions*/
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[6]= (w)->c.cons.car;
	local[7]= local[0];
	local[8]= makeflt(-1.0000000000000000000000e+00);
	local[9]= local[1];
	ctx->vsp=local+10;
	w=(*ftab[7])(ctx,2,local+8,&ftab[7],fqv[9]); /*scale-matrix*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)F98concatenate_matrix_row(ctx,2,local+7); /*concatenate-matrix-row*/
	local[7]= w;
	local[8]= local[1];
	local[9]= local[0];
	ctx->vsp=local+10;
	w=(pointer)F98concatenate_matrix_row(ctx,2,local+8); /*concatenate-matrix-row*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)F97concatenate_matrix_column(ctx,2,local+7); /*concatenate-matrix-column*/
	local[4] = w;
	local[7]= local[4];
	ctx->vsp=local+8;
	w=(*ftab[8])(ctx,1,local+7,&ftab[8],fqv[10]); /*matrix-determinant*/
	local[7]= w;
	local[8]= makeint((eusinteger_t)0L);
	ctx->vsp=local+9;
	w=(pointer)NUMEQUAL(ctx,2,local+7); /*=*/
	if (w==NIL) goto IF115;
	local[7]= fqv[11];
	ctx->vsp=local+8;
	w=(*ftab[4])(ctx,1,local+7,&ftab[4],fqv[6]); /*warn*/
	w = NIL;
	ctx->vsp=local+7;
	local[0]=w;
	goto BLK114;
	goto IF116;
IF115:
	local[7]= local[4];
	ctx->vsp=local+8;
	w=(pointer)F69inverse_matrix(ctx,1,local+7); /*inverse-matrix*/
	local[7]= w;
	local[8]= local[6];
	ctx->vsp=local+9;
	w=(*ftab[1])(ctx,1,local+8,&ftab[1],fqv[1]); /*unit-matrix*/
	local[8]= w;
	local[9]= local[6];
	local[10]= local[6];
	ctx->vsp=local+11;
	w=(*ftab[3])(ctx,2,local+9,&ftab[3],fqv[3]); /*make-matrix*/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)F97concatenate_matrix_column(ctx,2,local+8); /*concatenate-matrix-column*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)MATTIMES(ctx,2,local+7); /*m**/
	local[5] = w;
	local[7]= local[6];
	ctx->vsp=local+8;
	w=(*ftab[1])(ctx,1,local+7,&ftab[1],fqv[1]); /*unit-matrix*/
	local[7]= w;
	local[8]= local[6];
	local[9]= local[6];
	ctx->vsp=local+10;
	w=(*ftab[3])(ctx,2,local+8,&ftab[3],fqv[3]); /*make-matrix*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)F98concatenate_matrix_row(ctx,2,local+7); /*concatenate-matrix-row*/
	local[7]= w;
	local[8]= local[5];
	ctx->vsp=local+9;
	w=(pointer)MATTIMES(ctx,2,local+7); /*m**/
	local[2] = w;
	local[7]= local[6];
	local[8]= local[6];
	ctx->vsp=local+9;
	w=(*ftab[3])(ctx,2,local+7,&ftab[3],fqv[3]); /*make-matrix*/
	local[7]= w;
	local[8]= local[6];
	ctx->vsp=local+9;
	w=(*ftab[1])(ctx,1,local+8,&ftab[1],fqv[1]); /*unit-matrix*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)F98concatenate_matrix_row(ctx,2,local+7); /*concatenate-matrix-row*/
	local[7]= w;
	local[8]= local[5];
	ctx->vsp=local+9;
	w=(pointer)MATTIMES(ctx,2,local+7); /*m**/
	local[3] = w;
	local[7]= local[2];
	local[8]= local[3];
	ctx->vsp=local+9;
	w=(pointer)LIST(ctx,2,local+7); /*list*/
	local[7]= w;
IF116:
	w = local[7];
	local[0]= w;
BLK114:
	ctx->vsp=local; return(local[0]);}

/*m*-complex*/
static pointer F71m__complex(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=2) maerror();
	w=argv[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[0]= (w)->c.cons.car;
	w=argv[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	w=(w)->c.cons.cdr;
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[1]= (w)->c.cons.car;
	w=argv[1];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[2]= (w)->c.cons.car;
	w=argv[1];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	w=(w)->c.cons.cdr;
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[3]= (w)->c.cons.car;
	local[4]= local[0];
	local[5]= local[2];
	ctx->vsp=local+6;
	w=(pointer)MATTIMES(ctx,2,local+4); /*m**/
	local[4]= w;
	local[5]= local[1];
	local[6]= local[3];
	ctx->vsp=local+7;
	w=(pointer)MATTIMES(ctx,2,local+5); /*m**/
	local[5]= w;
	ctx->vsp=local+6;
	w=(*ftab[9])(ctx,2,local+4,&ftab[9],fqv[12]); /*m-*/
	local[4]= w;
	local[5]= local[0];
	local[6]= local[3];
	ctx->vsp=local+7;
	w=(pointer)MATTIMES(ctx,2,local+5); /*m**/
	local[5]= w;
	local[6]= local[1];
	local[7]= local[2];
	ctx->vsp=local+8;
	w=(pointer)MATTIMES(ctx,2,local+6); /*m**/
	local[6]= w;
	ctx->vsp=local+7;
	w=(*ftab[10])(ctx,2,local+5,&ftab[10],fqv[13]); /*m+*/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)LIST(ctx,2,local+4); /*list*/
	local[0]= w;
BLK117:
	ctx->vsp=local; return(local[0]);}

/*diagonal*/
static pointer F72diagonal(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	local[0]= argv[0];
	ctx->vsp=local+1;
	w=(pointer)LENGTH(ctx,1,local+0); /*length*/
	local[0]= w;
	local[1]= local[0];
	local[2]= local[0];
	ctx->vsp=local+3;
	w=(*ftab[3])(ctx,2,local+1,&ftab[3],fqv[3]); /*make-matrix*/
	local[1]= w;
	local[2]= makeint((eusinteger_t)0L);
	local[3]= local[0];
WHL120:
	local[4]= local[2];
	w = local[3];
	if ((eusinteger_t)local[4] >= (eusinteger_t)w) goto WHX121;
	local[4]= local[1];
	local[5]= local[2];
	local[6]= local[2];
	local[7]= argv[0];
	local[8]= local[2];
	ctx->vsp=local+9;
	w=(pointer)ELT(ctx,2,local+7); /*elt*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(pointer)ASET(ctx,4,local+4); /*aset*/
	local[4]= local[2];
	ctx->vsp=local+5;
	w=(pointer)ADD1(ctx,1,local+4); /*1+*/
	local[2] = w;
	goto WHL120;
WHX121:
	local[4]= NIL;
BLK122:
	w = NIL;
	w = local[1];
	local[0]= w;
BLK118:
	ctx->vsp=local; return(local[0]);}

/*minor-matrix*/
static pointer F73minor_matrix(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=3) maerror();
	local[0]= argv[0];
	local[1]= makeint((eusinteger_t)0L);
	ctx->vsp=local+2;
	w=(*ftab[0])(ctx,2,local+0,&ftab[0],fqv[0]); /*array-dimension*/
	local[0]= w;
	ctx->vsp=local+1;
	w=(pointer)SUB1(ctx,1,local+0); /*1-*/
	local[0]= w;
	local[1]= argv[0];
	local[2]= makeint((eusinteger_t)1L);
	ctx->vsp=local+3;
	w=(*ftab[0])(ctx,2,local+1,&ftab[0],fqv[0]); /*array-dimension*/
	local[1]= w;
	ctx->vsp=local+2;
	w=(pointer)SUB1(ctx,1,local+1); /*1-*/
	local[1]= w;
	local[2]= local[0];
	local[3]= local[1];
	ctx->vsp=local+4;
	w=(*ftab[3])(ctx,2,local+2,&ftab[3],fqv[3]); /*make-matrix*/
	local[2]= w;
	local[3]= makeint((eusinteger_t)0L);
	local[4]= makeint((eusinteger_t)0L);
TAG126:
	local[5]= local[3];
	local[6]= local[0];
	ctx->vsp=local+7;
	w=(pointer)NUMEQUAL(ctx,2,local+5); /*=*/
	if (w==NIL) goto IF127;
	w = NIL;
	ctx->vsp=local+5;
	local[3]=w;
	goto BLK125;
	goto IF128;
IF127:
	local[5]= NIL;
IF128:
	local[5]= local[4];
	local[6]= argv[1];
	ctx->vsp=local+7;
	w=(pointer)NUMEQUAL(ctx,2,local+5); /*=*/
	if (w==NIL) goto IF129;
	local[5]= local[4];
	ctx->vsp=local+6;
	w=(pointer)ADD1(ctx,1,local+5); /*1+*/
	local[4] = w;
	local[5]= local[4];
	goto IF130;
IF129:
	local[5]= NIL;
IF130:
	local[5]= makeint((eusinteger_t)0L);
	local[6]= makeint((eusinteger_t)0L);
TAG133:
	local[7]= local[5];
	local[8]= local[1];
	ctx->vsp=local+9;
	w=(pointer)NUMEQUAL(ctx,2,local+7); /*=*/
	if (w==NIL) goto IF134;
	w = NIL;
	ctx->vsp=local+7;
	local[5]=w;
	goto BLK132;
	goto IF135;
IF134:
	local[7]= NIL;
IF135:
	local[7]= local[6];
	local[8]= argv[2];
	ctx->vsp=local+9;
	w=(pointer)NUMEQUAL(ctx,2,local+7); /*=*/
	if (w==NIL) goto IF136;
	local[7]= local[6];
	ctx->vsp=local+8;
	w=(pointer)ADD1(ctx,1,local+7); /*1+*/
	local[6] = w;
	local[7]= local[6];
	goto IF137;
IF136:
	local[7]= NIL;
IF137:
	local[7]= local[2];
	local[8]= local[3];
	local[9]= local[5];
	local[10]= argv[0];
	local[11]= local[4];
	local[12]= local[6];
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)ASET(ctx,4,local+7); /*aset*/
	local[7]= local[5];
	ctx->vsp=local+8;
	w=(pointer)ADD1(ctx,1,local+7); /*1+*/
	local[7]= w;
	local[8]= local[6];
	ctx->vsp=local+9;
	w=(pointer)ADD1(ctx,1,local+8); /*1+*/
	local[8]= w;
	local[5] = local[7];
	local[6] = local[8];
	w = NIL;
	ctx->vsp=local+7;
	goto TAG133;
	w = NIL;
	local[5]= w;
BLK132:
	local[5]= local[3];
	ctx->vsp=local+6;
	w=(pointer)ADD1(ctx,1,local+5); /*1+*/
	local[5]= w;
	local[6]= local[4];
	ctx->vsp=local+7;
	w=(pointer)ADD1(ctx,1,local+6); /*1+*/
	local[6]= w;
	local[3] = local[5];
	local[4] = local[6];
	w = NIL;
	ctx->vsp=local+5;
	goto TAG126;
	w = NIL;
	local[3]= w;
BLK125:
	w = local[2];
	local[0]= w;
BLK123:
	ctx->vsp=local; return(local[0]);}

/*atan2*/
static pointer F74atan2(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=2) maerror();
	local[0]= makeflt(9.9999999999999964869129e-11);
	local[1]= local[0];
	ctx->vsp=local+2;
	w=(pointer)MINUS(ctx,1,local+1); /*-*/
	local[1]= w;
	local[2]= argv[1];
	local[3]= local[0];
	ctx->vsp=local+4;
	w=(pointer)GREATERP(ctx,2,local+2); /*>*/
	if (w==NIL) goto IF143;
	local[2]= argv[0];
	local[3]= argv[1];
	ctx->vsp=local+4;
	w=(pointer)QUOTIENT(ctx,2,local+2); /*/*/
	local[2]= w;
	ctx->vsp=local+3;
	w=(pointer)ATAN(ctx,1,local+2); /*atan*/
	ctx->vsp=local+2;
	local[0]=w;
	goto BLK142;
	goto IF144;
IF143:
	local[2]= NIL;
IF144:
	local[2]= argv[1];
	local[3]= local[1];
	ctx->vsp=local+4;
	w=(pointer)LESSP(ctx,2,local+2); /*<*/
	if (w==NIL) goto IF145;
	local[2]= argv[0];
	local[3]= makeint((eusinteger_t)0L);
	ctx->vsp=local+4;
	w=(pointer)GREATERP(ctx,2,local+2); /*>*/
	if (w==NIL) goto IF147;
	local[2]= makeflt(3.1415926535897931159980e+00);
	local[3]= argv[0];
	local[4]= argv[1];
	ctx->vsp=local+5;
	w=(pointer)QUOTIENT(ctx,2,local+3); /*/*/
	local[3]= w;
	ctx->vsp=local+4;
	w=(pointer)ATAN(ctx,1,local+3); /*atan*/
	{ double x,y;
		y=fltval(w); x=fltval(local[2]);
		local[2]=(makeflt(x + y));}
	w = local[2];
	ctx->vsp=local+2;
	local[0]=w;
	goto BLK142;
	goto IF148;
IF147:
	local[2]= argv[0];
	local[3]= argv[1];
	ctx->vsp=local+4;
	w=(pointer)QUOTIENT(ctx,2,local+2); /*/*/
	local[2]= w;
	ctx->vsp=local+3;
	w=(pointer)ATAN(ctx,1,local+2); /*atan*/
	local[2]= w;
	{ double x,y;
		y=fltval(makeflt(3.1415926535897931159980e+00)); x=fltval(local[2]);
		local[2]=(makeflt(x - y));}
	w = local[2];
	ctx->vsp=local+2;
	local[0]=w;
	goto BLK142;
IF148:
	goto IF146;
IF145:
	local[2]= NIL;
IF146:
	local[2]= argv[0];
	ctx->vsp=local+3;
	w=(pointer)ABS(ctx,1,local+2); /*abs*/
	local[2]= w;
	local[3]= local[0];
	ctx->vsp=local+4;
	w=(pointer)LESSP(ctx,2,local+2); /*<*/
	if (w==NIL) goto IF149;
	w = makeflt(0.0000000000000000000000e+00);
	ctx->vsp=local+2;
	local[0]=w;
	goto BLK142;
	goto IF150;
IF149:
	local[2]= NIL;
IF150:
	local[2]= argv[0];
	local[3]= makeint((eusinteger_t)0L);
	ctx->vsp=local+4;
	w=(pointer)GREATERP(ctx,2,local+2); /*>*/
	if (w==NIL) goto IF151;
	local[2]= makeflt(1.5707963267948965579990e+00);
	goto IF152;
IF151:
	local[2]= makeflt(-1.5707963267948965579990e+00);
IF152:
	w = local[2];
	local[0]= w;
BLK142:
	ctx->vsp=local; return(local[0]);}

/*outer-product-matrix*/
static pointer F75outer_product_matrix(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<1) maerror();
	if (n>=2) { local[0]=(argv[1]); goto ENT155;}
	local[0]= makeint((eusinteger_t)3L);
	ctx->vsp=local+1;
	w=(*ftab[1])(ctx,1,local+0,&ftab[1],fqv[1]); /*unit-matrix*/
	local[0]= w;
ENT155:
ENT154:
	if (n>2) maerror();
	local[1]= local[0];
	local[2]= makeint((eusinteger_t)0L);
	local[3]= makeint((eusinteger_t)0L);
	local[4]= makeint((eusinteger_t)0L);
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,4,local+1); /*aset*/
	local[1]= local[0];
	local[2]= makeint((eusinteger_t)0L);
	local[3]= makeint((eusinteger_t)1L);
	local[4]= argv[0];
	local[5]= makeint((eusinteger_t)2L);
	ctx->vsp=local+6;
	w=(pointer)AREF(ctx,2,local+4); /*aref*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)MINUS(ctx,1,local+4); /*-*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,4,local+1); /*aset*/
	local[1]= local[0];
	local[2]= makeint((eusinteger_t)0L);
	local[3]= makeint((eusinteger_t)2L);
	local[4]= argv[0];
	local[5]= makeint((eusinteger_t)1L);
	ctx->vsp=local+6;
	w=(pointer)AREF(ctx,2,local+4); /*aref*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,4,local+1); /*aset*/
	local[1]= local[0];
	local[2]= makeint((eusinteger_t)1L);
	local[3]= makeint((eusinteger_t)0L);
	local[4]= argv[0];
	local[5]= makeint((eusinteger_t)2L);
	ctx->vsp=local+6;
	w=(pointer)AREF(ctx,2,local+4); /*aref*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,4,local+1); /*aset*/
	local[1]= local[0];
	local[2]= makeint((eusinteger_t)1L);
	local[3]= makeint((eusinteger_t)1L);
	local[4]= makeint((eusinteger_t)0L);
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,4,local+1); /*aset*/
	local[1]= local[0];
	local[2]= makeint((eusinteger_t)1L);
	local[3]= makeint((eusinteger_t)2L);
	local[4]= argv[0];
	local[5]= makeint((eusinteger_t)0L);
	ctx->vsp=local+6;
	w=(pointer)AREF(ctx,2,local+4); /*aref*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)MINUS(ctx,1,local+4); /*-*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,4,local+1); /*aset*/
	local[1]= local[0];
	local[2]= makeint((eusinteger_t)2L);
	local[3]= makeint((eusinteger_t)0L);
	local[4]= argv[0];
	local[5]= makeint((eusinteger_t)1L);
	ctx->vsp=local+6;
	w=(pointer)AREF(ctx,2,local+4); /*aref*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)MINUS(ctx,1,local+4); /*-*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,4,local+1); /*aset*/
	local[1]= local[0];
	local[2]= makeint((eusinteger_t)2L);
	local[3]= makeint((eusinteger_t)1L);
	local[4]= argv[0];
	local[5]= makeint((eusinteger_t)0L);
	ctx->vsp=local+6;
	w=(pointer)AREF(ctx,2,local+4); /*aref*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,4,local+1); /*aset*/
	local[1]= local[0];
	local[2]= makeint((eusinteger_t)2L);
	local[3]= makeint((eusinteger_t)2L);
	local[4]= makeint((eusinteger_t)0L);
	ctx->vsp=local+5;
	w=(pointer)ASET(ctx,4,local+1); /*aset*/
	w = local[0];
	local[0]= w;
BLK153:
	ctx->vsp=local; return(local[0]);}

/*matrix2quaternion*/
static pointer F76matrix2quaternion(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	local[0]= NIL;
	local[1]= NIL;
	local[2]= NIL;
	local[3]= NIL;
	local[4]= NIL;
	local[5]= makeint((eusinteger_t)1L);
	local[6]= argv[0];
	local[7]= makeint((eusinteger_t)0L);
	local[8]= makeint((eusinteger_t)0L);
	ctx->vsp=local+9;
	w=(pointer)AREF(ctx,3,local+6); /*aref*/
	local[6]= w;
	local[7]= argv[0];
	local[8]= makeint((eusinteger_t)1L);
	local[9]= makeint((eusinteger_t)1L);
	ctx->vsp=local+10;
	w=(pointer)AREF(ctx,3,local+7); /*aref*/
	local[7]= w;
	local[8]= argv[0];
	local[9]= makeint((eusinteger_t)2L);
	local[10]= makeint((eusinteger_t)2L);
	ctx->vsp=local+11;
	w=(pointer)AREF(ctx,3,local+8); /*aref*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)PLUS(ctx,4,local+5); /*+*/
	local[5]= w;
	local[6]= makeint((eusinteger_t)4L);
	ctx->vsp=local+7;
	w=(pointer)QUOTIENT(ctx,2,local+5); /*/*/
	local[5]= w;
	local[6]= makeint((eusinteger_t)1L);
	local[7]= argv[0];
	local[8]= makeint((eusinteger_t)0L);
	local[9]= makeint((eusinteger_t)0L);
	ctx->vsp=local+10;
	w=(pointer)AREF(ctx,3,local+7); /*aref*/
	local[7]= w;
	local[8]= argv[0];
	local[9]= makeint((eusinteger_t)1L);
	local[10]= makeint((eusinteger_t)1L);
	ctx->vsp=local+11;
	w=(pointer)AREF(ctx,3,local+8); /*aref*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)MINUS(ctx,1,local+8); /*-*/
	local[8]= w;
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)2L);
	local[11]= makeint((eusinteger_t)2L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)MINUS(ctx,1,local+9); /*-*/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)PLUS(ctx,4,local+6); /*+*/
	local[6]= w;
	local[7]= makeint((eusinteger_t)4L);
	ctx->vsp=local+8;
	w=(pointer)QUOTIENT(ctx,2,local+6); /*/*/
	local[6]= w;
	local[7]= makeint((eusinteger_t)1L);
	local[8]= argv[0];
	local[9]= makeint((eusinteger_t)0L);
	local[10]= makeint((eusinteger_t)0L);
	ctx->vsp=local+11;
	w=(pointer)AREF(ctx,3,local+8); /*aref*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)MINUS(ctx,1,local+8); /*-*/
	local[8]= w;
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)1L);
	local[11]= makeint((eusinteger_t)1L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= makeint((eusinteger_t)2L);
	local[12]= makeint((eusinteger_t)2L);
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)MINUS(ctx,1,local+10); /*-*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)PLUS(ctx,4,local+7); /*+*/
	local[7]= w;
	local[8]= makeint((eusinteger_t)4L);
	ctx->vsp=local+9;
	w=(pointer)QUOTIENT(ctx,2,local+7); /*/*/
	local[7]= w;
	local[8]= makeint((eusinteger_t)1L);
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)0L);
	local[11]= makeint((eusinteger_t)0L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)MINUS(ctx,1,local+9); /*-*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= makeint((eusinteger_t)1L);
	local[12]= makeint((eusinteger_t)1L);
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)MINUS(ctx,1,local+10); /*-*/
	local[10]= w;
	local[11]= argv[0];
	local[12]= makeint((eusinteger_t)2L);
	local[13]= makeint((eusinteger_t)2L);
	ctx->vsp=local+14;
	w=(pointer)AREF(ctx,3,local+11); /*aref*/
	local[11]= w;
	ctx->vsp=local+12;
	w=(pointer)PLUS(ctx,4,local+8); /*+*/
	local[8]= w;
	local[9]= makeint((eusinteger_t)4L);
	ctx->vsp=local+10;
	w=(pointer)QUOTIENT(ctx,2,local+8); /*/*/
	local[8]= w;
	local[9]= local[5];
	local[10]= local[6];
	local[11]= local[7];
	local[12]= local[8];
	ctx->vsp=local+13;
	w=(pointer)MAX(ctx,4,local+9); /*max*/
	local[4] = w;
	local[9]= local[4];
	local[10]= local[5];
	ctx->vsp=local+11;
	w=(*ftab[11])(ctx,2,local+9,&ftab[11],fqv[14]); /*eps=*/
	if (w==NIL) goto CON158;
	local[9]= local[5];
	ctx->vsp=local+10;
	w=(pointer)SQRT(ctx,1,local+9); /*sqrt*/
	local[0] = w;
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)2L);
	local[11]= makeint((eusinteger_t)1L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= makeint((eusinteger_t)1L);
	local[12]= makeint((eusinteger_t)2L);
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)MINUS(ctx,2,local+9); /*-*/
	local[9]= w;
	local[10]= makeint((eusinteger_t)4L);
	local[11]= local[0];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)QUOTIENT(ctx,2,local+9); /*/*/
	local[1] = w;
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)0L);
	local[11]= makeint((eusinteger_t)2L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= makeint((eusinteger_t)2L);
	local[12]= makeint((eusinteger_t)0L);
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)MINUS(ctx,2,local+9); /*-*/
	local[9]= w;
	local[10]= makeint((eusinteger_t)4L);
	local[11]= local[0];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)QUOTIENT(ctx,2,local+9); /*/*/
	local[2] = w;
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)1L);
	local[11]= makeint((eusinteger_t)0L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= makeint((eusinteger_t)0L);
	local[12]= makeint((eusinteger_t)1L);
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)MINUS(ctx,2,local+9); /*-*/
	local[9]= w;
	local[10]= makeint((eusinteger_t)4L);
	local[11]= local[0];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)QUOTIENT(ctx,2,local+9); /*/*/
	local[3] = w;
	local[9]= local[3];
	goto CON157;
CON158:
	local[9]= local[4];
	local[10]= local[6];
	ctx->vsp=local+11;
	w=(*ftab[11])(ctx,2,local+9,&ftab[11],fqv[14]); /*eps=*/
	if (w==NIL) goto CON159;
	local[9]= local[6];
	ctx->vsp=local+10;
	w=(pointer)SQRT(ctx,1,local+9); /*sqrt*/
	local[1] = w;
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)2L);
	local[11]= makeint((eusinteger_t)1L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= makeint((eusinteger_t)1L);
	local[12]= makeint((eusinteger_t)2L);
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)MINUS(ctx,2,local+9); /*-*/
	local[9]= w;
	local[10]= makeint((eusinteger_t)4L);
	local[11]= local[1];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)QUOTIENT(ctx,2,local+9); /*/*/
	local[0] = w;
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)0L);
	local[11]= makeint((eusinteger_t)1L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= makeint((eusinteger_t)1L);
	local[12]= makeint((eusinteger_t)0L);
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)PLUS(ctx,2,local+9); /*+*/
	local[9]= w;
	local[10]= makeint((eusinteger_t)4L);
	local[11]= local[1];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)QUOTIENT(ctx,2,local+9); /*/*/
	local[2] = w;
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)0L);
	local[11]= makeint((eusinteger_t)2L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= makeint((eusinteger_t)2L);
	local[12]= makeint((eusinteger_t)0L);
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)PLUS(ctx,2,local+9); /*+*/
	local[9]= w;
	local[10]= makeint((eusinteger_t)4L);
	local[11]= local[1];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)QUOTIENT(ctx,2,local+9); /*/*/
	local[3] = w;
	local[9]= local[3];
	goto CON157;
CON159:
	local[9]= local[4];
	local[10]= local[7];
	ctx->vsp=local+11;
	w=(*ftab[11])(ctx,2,local+9,&ftab[11],fqv[14]); /*eps=*/
	if (w==NIL) goto CON160;
	local[9]= local[7];
	ctx->vsp=local+10;
	w=(pointer)SQRT(ctx,1,local+9); /*sqrt*/
	local[2] = w;
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)0L);
	local[11]= makeint((eusinteger_t)2L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= makeint((eusinteger_t)2L);
	local[12]= makeint((eusinteger_t)0L);
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)MINUS(ctx,2,local+9); /*-*/
	local[9]= w;
	local[10]= makeint((eusinteger_t)4L);
	local[11]= local[2];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)QUOTIENT(ctx,2,local+9); /*/*/
	local[0] = w;
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)0L);
	local[11]= makeint((eusinteger_t)1L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= makeint((eusinteger_t)1L);
	local[12]= makeint((eusinteger_t)0L);
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)PLUS(ctx,2,local+9); /*+*/
	local[9]= w;
	local[10]= makeint((eusinteger_t)4L);
	local[11]= local[2];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)QUOTIENT(ctx,2,local+9); /*/*/
	local[1] = w;
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)1L);
	local[11]= makeint((eusinteger_t)2L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= makeint((eusinteger_t)2L);
	local[12]= makeint((eusinteger_t)1L);
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)PLUS(ctx,2,local+9); /*+*/
	local[9]= w;
	local[10]= makeint((eusinteger_t)4L);
	local[11]= local[2];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)QUOTIENT(ctx,2,local+9); /*/*/
	local[3] = w;
	local[9]= local[3];
	goto CON157;
CON160:
	local[9]= local[4];
	local[10]= local[8];
	ctx->vsp=local+11;
	w=(*ftab[11])(ctx,2,local+9,&ftab[11],fqv[14]); /*eps=*/
	if (w==NIL) goto CON161;
	local[9]= local[8];
	ctx->vsp=local+10;
	w=(pointer)SQRT(ctx,1,local+9); /*sqrt*/
	local[3] = w;
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)1L);
	local[11]= makeint((eusinteger_t)0L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= makeint((eusinteger_t)0L);
	local[12]= makeint((eusinteger_t)1L);
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)MINUS(ctx,2,local+9); /*-*/
	local[9]= w;
	local[10]= makeint((eusinteger_t)4L);
	local[11]= local[3];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)QUOTIENT(ctx,2,local+9); /*/*/
	local[0] = w;
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)0L);
	local[11]= makeint((eusinteger_t)2L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= makeint((eusinteger_t)2L);
	local[12]= makeint((eusinteger_t)0L);
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)PLUS(ctx,2,local+9); /*+*/
	local[9]= w;
	local[10]= makeint((eusinteger_t)4L);
	local[11]= local[3];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)QUOTIENT(ctx,2,local+9); /*/*/
	local[1] = w;
	local[9]= argv[0];
	local[10]= makeint((eusinteger_t)1L);
	local[11]= makeint((eusinteger_t)2L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= makeint((eusinteger_t)2L);
	local[12]= makeint((eusinteger_t)1L);
	ctx->vsp=local+13;
	w=(pointer)AREF(ctx,3,local+10); /*aref*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)PLUS(ctx,2,local+9); /*+*/
	local[9]= w;
	local[10]= makeint((eusinteger_t)4L);
	local[11]= local[3];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)QUOTIENT(ctx,2,local+9); /*/*/
	local[2] = w;
	local[9]= local[2];
	goto CON157;
CON161:
	local[9]= fqv[15];
	ctx->vsp=local+10;
	w=(*ftab[4])(ctx,1,local+9,&ftab[4],fqv[6]); /*warn*/
	local[9]= w;
	goto CON157;
CON162:
	local[9]= NIL;
CON157:
	local[9]= local[0];
	local[10]= local[1];
	local[11]= local[2];
	local[12]= local[3];
	ctx->vsp=local+13;
	w=(pointer)MKFLTVEC(ctx,4,local+9); /*float-vector*/
	local[0]= w;
BLK156:
	ctx->vsp=local; return(local[0]);}

/*quaternion2matrix*/
static pointer F77quaternion2matrix(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	local[0]= argv[0];
	local[1]= makeint((eusinteger_t)0L);
	ctx->vsp=local+2;
	w=(pointer)ELT(ctx,2,local+0); /*elt*/
	local[0]= w;
	local[1]= argv[0];
	local[2]= makeint((eusinteger_t)1L);
	ctx->vsp=local+3;
	w=(pointer)ELT(ctx,2,local+1); /*elt*/
	local[1]= w;
	local[2]= argv[0];
	local[3]= makeint((eusinteger_t)2L);
	ctx->vsp=local+4;
	w=(pointer)ELT(ctx,2,local+2); /*elt*/
	local[2]= w;
	local[3]= argv[0];
	local[4]= makeint((eusinteger_t)3L);
	ctx->vsp=local+5;
	w=(pointer)ELT(ctx,2,local+3); /*elt*/
	local[3]= w;
	local[4]= argv[0];
	local[5]= argv[0];
	ctx->vsp=local+6;
	w=(pointer)VINNERPRODUCT(ctx,2,local+4); /*v.*/
	local[4]= w;
	local[5]= makeflt(1.0000000000000000000000e+00);
	local[6]= makeflt(9.9999999999999950039964e-03);
	ctx->vsp=local+7;
	w=(*ftab[11])(ctx,3,local+4,&ftab[11],fqv[14]); /*eps=*/
	if (w!=NIL) goto IF164;
	local[4]= makeint((eusinteger_t)1L);
	local[5]= fqv[16];
	local[6]= argv[0];
	ctx->vsp=local+7;
	w=(*ftab[12])(ctx,3,local+4,&ftab[12],fqv[17]); /*warning-message*/
	local[4]= w;
	goto IF165;
IF164:
	local[4]= NIL;
IF165:
	local[4]= makeint((eusinteger_t)3L);
	local[5]= makeint((eusinteger_t)3L);
	local[6]= local[0];
	local[7]= local[0];
	ctx->vsp=local+8;
	w=(pointer)TIMES(ctx,2,local+6); /***/
	local[6]= w;
	local[7]= local[1];
	local[8]= local[1];
	ctx->vsp=local+9;
	w=(pointer)TIMES(ctx,2,local+7); /***/
	local[7]= w;
	local[8]= local[2];
	local[9]= local[2];
	ctx->vsp=local+10;
	w=(pointer)TIMES(ctx,2,local+8); /***/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)MINUS(ctx,1,local+8); /*-*/
	local[8]= w;
	local[9]= local[3];
	local[10]= local[3];
	ctx->vsp=local+11;
	w=(pointer)TIMES(ctx,2,local+9); /***/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)MINUS(ctx,1,local+9); /*-*/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)PLUS(ctx,4,local+6); /*+*/
	local[6]= w;
	local[7]= makeint((eusinteger_t)2L);
	local[8]= local[1];
	local[9]= local[2];
	ctx->vsp=local+10;
	w=(pointer)TIMES(ctx,2,local+8); /***/
	local[8]= w;
	local[9]= local[0];
	local[10]= local[3];
	ctx->vsp=local+11;
	w=(pointer)TIMES(ctx,2,local+9); /***/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)MINUS(ctx,2,local+8); /*-*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)TIMES(ctx,2,local+7); /***/
	local[7]= w;
	local[8]= makeint((eusinteger_t)2L);
	local[9]= local[1];
	local[10]= local[3];
	ctx->vsp=local+11;
	w=(pointer)TIMES(ctx,2,local+9); /***/
	local[9]= w;
	local[10]= local[0];
	local[11]= local[2];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)PLUS(ctx,2,local+9); /*+*/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)TIMES(ctx,2,local+8); /***/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)MKFLTVEC(ctx,3,local+6); /*float-vector*/
	local[6]= w;
	local[7]= makeint((eusinteger_t)2L);
	local[8]= local[1];
	local[9]= local[2];
	ctx->vsp=local+10;
	w=(pointer)TIMES(ctx,2,local+8); /***/
	local[8]= w;
	local[9]= local[0];
	local[10]= local[3];
	ctx->vsp=local+11;
	w=(pointer)TIMES(ctx,2,local+9); /***/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)PLUS(ctx,2,local+8); /*+*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)TIMES(ctx,2,local+7); /***/
	local[7]= w;
	local[8]= local[0];
	local[9]= local[0];
	ctx->vsp=local+10;
	w=(pointer)TIMES(ctx,2,local+8); /***/
	local[8]= w;
	local[9]= local[1];
	local[10]= local[1];
	ctx->vsp=local+11;
	w=(pointer)TIMES(ctx,2,local+9); /***/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)MINUS(ctx,1,local+9); /*-*/
	local[9]= w;
	local[10]= local[2];
	local[11]= local[2];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	local[11]= local[3];
	local[12]= local[3];
	ctx->vsp=local+13;
	w=(pointer)TIMES(ctx,2,local+11); /***/
	local[11]= w;
	ctx->vsp=local+12;
	w=(pointer)MINUS(ctx,1,local+11); /*-*/
	local[11]= w;
	ctx->vsp=local+12;
	w=(pointer)PLUS(ctx,4,local+8); /*+*/
	local[8]= w;
	local[9]= makeint((eusinteger_t)2L);
	local[10]= local[2];
	local[11]= local[3];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	local[11]= local[0];
	local[12]= local[1];
	ctx->vsp=local+13;
	w=(pointer)TIMES(ctx,2,local+11); /***/
	local[11]= w;
	ctx->vsp=local+12;
	w=(pointer)MINUS(ctx,2,local+10); /*-*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)TIMES(ctx,2,local+9); /***/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)MKFLTVEC(ctx,3,local+7); /*float-vector*/
	local[7]= w;
	local[8]= makeint((eusinteger_t)2L);
	local[9]= local[1];
	local[10]= local[3];
	ctx->vsp=local+11;
	w=(pointer)TIMES(ctx,2,local+9); /***/
	local[9]= w;
	local[10]= local[0];
	local[11]= local[2];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)MINUS(ctx,2,local+9); /*-*/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)TIMES(ctx,2,local+8); /***/
	local[8]= w;
	local[9]= makeint((eusinteger_t)2L);
	local[10]= local[2];
	local[11]= local[3];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	local[11]= local[0];
	local[12]= local[1];
	ctx->vsp=local+13;
	w=(pointer)TIMES(ctx,2,local+11); /***/
	local[11]= w;
	ctx->vsp=local+12;
	w=(pointer)PLUS(ctx,2,local+10); /*+*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)TIMES(ctx,2,local+9); /***/
	local[9]= w;
	local[10]= local[0];
	local[11]= local[0];
	ctx->vsp=local+12;
	w=(pointer)TIMES(ctx,2,local+10); /***/
	local[10]= w;
	local[11]= local[1];
	local[12]= local[1];
	ctx->vsp=local+13;
	w=(pointer)TIMES(ctx,2,local+11); /***/
	local[11]= w;
	ctx->vsp=local+12;
	w=(pointer)MINUS(ctx,1,local+11); /*-*/
	local[11]= w;
	local[12]= local[2];
	local[13]= local[2];
	ctx->vsp=local+14;
	w=(pointer)TIMES(ctx,2,local+12); /***/
	local[12]= w;
	ctx->vsp=local+13;
	w=(pointer)MINUS(ctx,1,local+12); /*-*/
	local[12]= w;
	local[13]= local[3];
	local[14]= local[3];
	ctx->vsp=local+15;
	w=(pointer)TIMES(ctx,2,local+13); /***/
	local[13]= w;
	ctx->vsp=local+14;
	w=(pointer)PLUS(ctx,4,local+10); /*+*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(pointer)MKFLTVEC(ctx,3,local+8); /*float-vector*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)LIST(ctx,3,local+6); /*list*/
	local[6]= w;
	ctx->vsp=local+7;
	w=(*ftab[3])(ctx,3,local+4,&ftab[3],fqv[3]); /*make-matrix*/
	local[0]= w;
BLK163:
	ctx->vsp=local; return(local[0]);}

/*matrix-log*/
static pointer F78matrix_log(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	local[0]= argv[0];
	ctx->vsp=local+1;
	w=(pointer)F76matrix2quaternion(ctx,1,local+0); /*matrix2quaternion*/
	local[0]= w;
	local[1]= local[0];
	local[2]= makeint((eusinteger_t)0L);
	ctx->vsp=local+3;
	w=(pointer)ELT(ctx,2,local+1); /*elt*/
	local[1]= w;
	local[2]= local[0];
	local[3]= makeint((eusinteger_t)1L);
	local[4]= makeint((eusinteger_t)4L);
	ctx->vsp=local+5;
	w=(pointer)SUBSEQ(ctx,3,local+2); /*subseq*/
	local[2]= w;
	local[3]= makeflt(2.0000000000000000000000e+00);
	local[4]= local[2];
	ctx->vsp=local+5;
	w=(pointer)VNORM(ctx,1,local+4); /*norm*/
	local[4]= w;
	local[5]= local[1];
	ctx->vsp=local+6;
	w=(pointer)ATAN(ctx,2,local+4); /*atan*/
	{ double x,y;
		y=fltval(w); x=fltval(local[3]);
		local[3]=(makeflt(x * y));}
	local[4]= local[3];
	local[5]= makeflt(3.1415926535897931159980e+00);
	ctx->vsp=local+6;
	w=(pointer)GREATERP(ctx,2,local+4); /*>*/
	if (w==NIL) goto CON168;
	local[4]= local[3];
	local[5]= makeflt(6.2831853071795862319959e+00);
	ctx->vsp=local+6;
	w=(pointer)MINUS(ctx,2,local+4); /*-*/
	local[3] = w;
	local[4]= local[3];
	goto CON167;
CON168:
	local[4]= local[3];
	local[5]= makeflt(-3.1415926535897931159980e+00);
	ctx->vsp=local+6;
	w=(pointer)LESSP(ctx,2,local+4); /*<*/
	if (w==NIL) goto CON169;
	local[4]= local[3];
	local[5]= makeflt(6.2831853071795862319959e+00);
	ctx->vsp=local+6;
	w=(pointer)PLUS(ctx,2,local+4); /*+*/
	local[3] = w;
	local[4]= local[3];
	goto CON167;
CON169:
	local[4]= NIL;
CON167:
	local[4]= local[3];
	local[5]= local[2];
	ctx->vsp=local+6;
	w=(pointer)F102normalize_vector(ctx,1,local+5); /*normalize-vector*/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)SCALEVEC(ctx,2,local+4); /*scale*/
	local[0]= w;
BLK166:
	ctx->vsp=local; return(local[0]);}

/*matrix-exponent*/
static pointer F79matrix_exponent(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<1) maerror();
	if (n>=2) { local[0]=(argv[1]); goto ENT172;}
	local[0]= makeflt(1.0000000000000000000000e+00);
ENT172:
ENT171:
	if (n>2) maerror();
	local[1]= NIL;
	local[2]= NIL;
	local[3]= argv[0];
	ctx->vsp=local+4;
	w=(pointer)VNORM(ctx,1,local+3); /*norm*/
	local[1] = w;
	local[3]= argv[0];
	ctx->vsp=local+4;
	w=(pointer)F102normalize_vector(ctx,1,local+3); /*normalize-vector*/
	local[3]= w;
	ctx->vsp=local+4;
	w=(pointer)F75outer_product_matrix(ctx,1,local+3); /*outer-product-matrix*/
	local[2] = w;
	ctx->vsp=local+3;
	w=(*ftab[1])(ctx,0,local+3,&ftab[1],fqv[1]); /*unit-matrix*/
	local[3]= w;
	local[4]= local[1];
	local[5]= local[0];
	ctx->vsp=local+6;
	w=(pointer)TIMES(ctx,2,local+4); /***/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)SIN(ctx,1,local+4); /*sin*/
	local[4]= w;
	local[5]= local[2];
	ctx->vsp=local+6;
	w=(*ftab[7])(ctx,2,local+4,&ftab[7],fqv[9]); /*scale-matrix*/
	local[4]= w;
	local[5]= makeflt(1.0000000000000000000000e+00);
	local[6]= local[1];
	local[7]= local[0];
	ctx->vsp=local+8;
	w=(pointer)TIMES(ctx,2,local+6); /***/
	local[6]= w;
	ctx->vsp=local+7;
	w=(pointer)COS(ctx,1,local+6); /*cos*/
	{ double x,y;
		y=fltval(w); x=fltval(local[5]);
		local[5]=(makeflt(x - y));}
	local[6]= local[2];
	local[7]= local[2];
	ctx->vsp=local+8;
	w=(pointer)MATTIMES(ctx,2,local+6); /*m**/
	local[6]= w;
	ctx->vsp=local+7;
	w=(*ftab[7])(ctx,2,local+5,&ftab[7],fqv[9]); /*scale-matrix*/
	local[5]= w;
	ctx->vsp=local+6;
	w=(*ftab[10])(ctx,2,local+4,&ftab[10],fqv[13]); /*m+*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(*ftab[10])(ctx,2,local+3,&ftab[10],fqv[13]); /*m+*/
	local[0]= w;
BLK170:
	ctx->vsp=local; return(local[0]);}

/*midrot*/
static pointer F80midrot(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=3) maerror();
	local[0]= NIL;
	local[1]= NIL;
	local[2]= argv[1];
	ctx->vsp=local+3;
	w=(pointer)TRANSPOSE(ctx,1,local+2); /*transpose*/
	local[2]= w;
	local[3]= argv[2];
	ctx->vsp=local+4;
	w=(pointer)MATTIMES(ctx,2,local+2); /*m**/
	local[0] = w;
	local[2]= local[0];
	ctx->vsp=local+3;
	w=(pointer)F78matrix_log(ctx,1,local+2); /*matrix-log*/
	local[1] = w;
	local[2]= local[1];
	local[3]= argv[0];
	ctx->vsp=local+4;
	w=(pointer)F79matrix_exponent(ctx,2,local+2); /*matrix-exponent*/
	local[0] = w;
	local[2]= argv[1];
	local[3]= local[0];
	ctx->vsp=local+4;
	w=(pointer)MATTIMES(ctx,2,local+2); /*m**/
	local[0]= w;
BLK173:
	ctx->vsp=local; return(local[0]);}

/*pseudo-inverse*/
static pointer F81pseudo_inverse(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<1) maerror();
	if (n>=2) { local[0]=(argv[1]); goto ENT179;}
	local[0]= NIL;
ENT179:
	if (n>=3) { local[1]=(argv[2]); goto ENT178;}
	local[1]= NIL;
ENT178:
	if (n>=4) { local[2]=(argv[3]); goto ENT177;}
	local[2]= NIL;
ENT177:
	if (n>=5) { local[3]=(argv[4]); goto ENT176;}
	local[3]= NIL;
ENT176:
ENT175:
	if (n>5) maerror();
	local[4]= argv[0];
	local[5]= makeint((eusinteger_t)0L);
	ctx->vsp=local+6;
	w=(*ftab[0])(ctx,2,local+4,&ftab[0],fqv[0]); /*array-dimension*/
	local[4]= w;
	local[5]= argv[0];
	local[6]= makeint((eusinteger_t)1L);
	ctx->vsp=local+7;
	w=(*ftab[0])(ctx,2,local+5,&ftab[0],fqv[0]); /*array-dimension*/
	local[5]= w;
	local[6]= NIL;
	local[7]= NIL;
	local[8]= NIL;
	if (local[1]!=NIL) goto IF180;
	local[9]= local[5];
	local[10]= local[4];
	ctx->vsp=local+11;
	w=(*ftab[3])(ctx,2,local+9,&ftab[3],fqv[3]); /*make-matrix*/
	local[1] = w;
	local[9]= local[1];
	goto IF181;
IF180:
	local[9]= NIL;
IF181:
	if (local[0]!=NIL) goto IF182;
	local[9]= argv[0];
	local[10]= local[1];
	ctx->vsp=local+11;
	w=(*ftab[13])(ctx,2,local+9,&ftab[13],fqv[18]); /*pseudo-inverse2*/
	ctx->vsp=local+9;
	local[0]=w;
	goto BLK174;
	goto IF183;
IF182:
	local[9]= NIL;
IF183:
	local[9]= local[4];
	local[10]= local[5];
	ctx->vsp=local+11;
	w=(pointer)MAX(ctx,2,local+9); /*max*/
	local[6] = w;
	if (local[2]!=NIL) goto IF184;
	local[9]= local[6];
	local[10]= local[6];
	ctx->vsp=local+11;
	w=(*ftab[3])(ctx,2,local+9,&ftab[3],fqv[3]); /*make-matrix*/
	local[2] = w;
	local[9]= local[2];
	goto IF185;
IF184:
	local[9]= NIL;
IF185:
	if (local[3]!=NIL) goto IF186;
	local[9]= local[4];
	local[10]= local[5];
	ctx->vsp=local+11;
	w=(*ftab[3])(ctx,2,local+9,&ftab[3],fqv[3]); /*make-matrix*/
	local[3] = w;
	local[9]= local[3];
	goto IF187;
IF186:
	local[9]= NIL;
IF187:
	local[9]= makeint((eusinteger_t)0L);
	local[10]= local[6];
WHL189:
	local[11]= local[9];
	w = local[10];
	if ((eusinteger_t)local[11] >= (eusinteger_t)w) goto WHX190;
	local[11]= local[2];
	local[12]= local[9];
	local[13]= local[9];
	local[14]= local[0];
	local[15]= local[9];
	ctx->vsp=local+16;
	w=(pointer)AREF(ctx,2,local+14); /*aref*/
	local[14]= w;
	ctx->vsp=local+15;
	w=(pointer)SQRT(ctx,1,local+14); /*sqrt*/
	local[14]= w;
	ctx->vsp=local+15;
	w=(pointer)ASET(ctx,4,local+11); /*aset*/
	local[11]= local[9];
	ctx->vsp=local+12;
	w=(pointer)ADD1(ctx,1,local+11); /*1+*/
	local[9] = w;
	goto WHL189;
WHX190:
	local[11]= NIL;
BLK191:
	w = NIL;
	local[9]= local[4];
	local[10]= local[5];
	ctx->vsp=local+11;
	w=(pointer)LSEQP(ctx,2,local+9); /*<=*/
	if (w==NIL) goto IF192;
	local[9]= argv[0];
	local[10]= local[2];
	local[11]= local[3];
	ctx->vsp=local+12;
	w=(pointer)MATTIMES(ctx,3,local+9); /*m**/
	local[9]= w;
	local[10]= local[1];
	ctx->vsp=local+11;
	w=(*ftab[13])(ctx,2,local+9,&ftab[13],fqv[18]); /*pseudo-inverse2*/
	local[7] = w;
	if (local[7]==NIL) goto IF194;
	local[9]= local[2];
	local[10]= local[7];
	local[11]= local[1];
	ctx->vsp=local+12;
	w=(pointer)MATTIMES(ctx,3,local+9); /*m**/
	local[9]= w;
	goto IF195;
IF194:
	local[9]= NIL;
IF195:
	goto IF193;
IF192:
	local[9]= local[2];
	local[10]= argv[0];
	local[11]= local[3];
	ctx->vsp=local+12;
	w=(pointer)MATTIMES(ctx,3,local+9); /*m**/
	local[9]= w;
	local[10]= local[1];
	ctx->vsp=local+11;
	w=(*ftab[13])(ctx,2,local+9,&ftab[13],fqv[18]); /*pseudo-inverse2*/
	local[7] = w;
	if (local[7]==NIL) goto IF196;
	local[9]= local[7];
	local[10]= local[2];
	local[11]= local[1];
	ctx->vsp=local+12;
	w=(pointer)MATTIMES(ctx,3,local+9); /*m**/
	local[9]= w;
	goto IF197;
IF196:
	local[9]= NIL;
IF197:
IF193:
	w = local[9];
	local[0]= w;
BLK174:
	ctx->vsp=local; return(local[0]);}

/*pseudo-inverse-org*/
static pointer F82pseudo_inverse_org(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<1) maerror();
	if (n>=2) { local[0]=(argv[1]); goto ENT202;}
	local[0]= NIL;
ENT202:
	if (n>=3) { local[1]=(argv[2]); goto ENT201;}
	local[1]= NIL;
ENT201:
	if (n>=4) { local[2]=(argv[3]); goto ENT200;}
	local[2]= NIL;
ENT200:
ENT199:
	if (n>4) maerror();
	local[3]= NIL;
	local[4]= NIL;
	local[5]= NIL;
	local[6]= NIL;
	local[7]= NIL;
	local[8]= NIL;
	local[9]= argv[0];
	ctx->vsp=local+10;
	w=(*ftab[6])(ctx,1,local+9,&ftab[6],fqv[8]); /*array-dimensions*/
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	w=(w)->c.cons.cdr;
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[3] = (w)->c.cons.car;
	local[9]= argv[0];
	ctx->vsp=local+10;
	w=(*ftab[14])(ctx,1,local+9,&ftab[14],fqv[19]); /*sv-decompose*/
	local[4] = w;
	if (local[4]!=NIL) goto IF203;
	local[9]= fqv[20];
	local[10]= argv[0];
	ctx->vsp=local+11;
	w=(*ftab[4])(ctx,2,local+9,&ftab[4],fqv[6]); /*warn*/
	w = NIL;
	ctx->vsp=local+9;
	local[0]=w;
	goto BLK198;
	goto IF204;
IF203:
	local[9]= NIL;
IF204:
	local[9]= local[4];
	local[10]= makeint((eusinteger_t)0L);
	ctx->vsp=local+11;
	w=(pointer)ELT(ctx,2,local+9); /*elt*/
	local[5] = w;
	local[9]= local[4];
	local[10]= makeint((eusinteger_t)1L);
	ctx->vsp=local+11;
	w=(pointer)ELT(ctx,2,local+9); /*elt*/
	local[6] = w;
	local[9]= local[4];
	local[10]= makeint((eusinteger_t)2L);
	ctx->vsp=local+11;
	w=(pointer)ELT(ctx,2,local+9); /*elt*/
	local[7] = w;
	if (local[1]!=NIL) goto IF205;
	local[9]= local[3];
	local[10]= local[3];
	ctx->vsp=local+11;
	w=(*ftab[3])(ctx,2,local+9,&ftab[3],fqv[3]); /*make-matrix*/
	local[1] = w;
	local[9]= local[1];
	goto IF206;
IF205:
	local[9]= NIL;
IF206:
	if (local[2]!=NIL) goto IF207;
	local[9]= local[3];
	local[10]= argv[0];
	ctx->vsp=local+11;
	w=(*ftab[6])(ctx,1,local+10,&ftab[6],fqv[8]); /*array-dimensions*/
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[10]= (w)->c.cons.car;
	ctx->vsp=local+11;
	w=(*ftab[3])(ctx,2,local+9,&ftab[3],fqv[3]); /*make-matrix*/
	local[2] = w;
	local[9]= local[2];
	goto IF208;
IF207:
	local[9]= NIL;
IF208:
	if (local[0]!=NIL) goto IF209;
	local[9]= local[3];
	local[10]= argv[0];
	ctx->vsp=local+11;
	w=(*ftab[6])(ctx,1,local+10,&ftab[6],fqv[8]); /*array-dimensions*/
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[10]= (w)->c.cons.car;
	ctx->vsp=local+11;
	w=(*ftab[3])(ctx,2,local+9,&ftab[3],fqv[3]); /*make-matrix*/
	local[0] = w;
	local[9]= local[0];
	goto IF210;
IF209:
	local[9]= NIL;
IF210:
	local[9]= local[1]->c.obj.iv[1];
	local[10]= makeint((eusinteger_t)0L);
	ctx->vsp=local+11;
	w=(*ftab[15])(ctx,2,local+9,&ftab[15],fqv[21]); /*fill*/
	local[9]= local[6];
	local[10]= makeint((eusinteger_t)0L);
	local[11]= makeint((eusinteger_t)0L);
	ctx->vsp=local+12;
	w=(pointer)AREF(ctx,3,local+9); /*aref*/
	local[8] = w;
	local[9]= local[8];
	local[10]= makeflt(9.9999999999999991239646e-05);
	ctx->vsp=local+11;
	w=(pointer)GREATERP(ctx,2,local+9); /*>*/
	if (w==NIL) goto IF211;
	local[9]= makeint((eusinteger_t)0L);
	local[10]= local[3];
WHL214:
	local[11]= local[9];
	w = local[10];
	if ((eusinteger_t)local[11] >= (eusinteger_t)w) goto WHX215;
	local[11]= local[6];
	local[12]= local[9];
	local[13]= local[9];
	ctx->vsp=local+14;
	w=(pointer)AREF(ctx,3,local+11); /*aref*/
	local[11]= w;
	local[12]= local[8];
	ctx->vsp=local+13;
	w=(pointer)QUOTIENT(ctx,2,local+11); /*/*/
	local[11]= w;
	local[12]= makeflt(9.9999999999999991239646e-05);
	ctx->vsp=local+13;
	w=(pointer)GREATERP(ctx,2,local+11); /*>*/
	if (w==NIL) goto IF217;
	local[11]= local[1];
	local[12]= local[9];
	local[13]= local[9];
	local[14]= makeflt(1.0000000000000000000000e+00);
	local[15]= local[6];
	local[16]= local[9];
	local[17]= local[9];
	ctx->vsp=local+18;
	w=(pointer)AREF(ctx,3,local+15); /*aref*/
	local[15]= w;
	ctx->vsp=local+16;
	w=(pointer)QUOTIENT(ctx,2,local+14); /*/*/
	local[14]= w;
	ctx->vsp=local+15;
	w=(pointer)ASET(ctx,4,local+11); /*aset*/
	local[11]= w;
	goto IF218;
IF217:
	local[11]= NIL;
IF218:
	local[11]= local[9];
	ctx->vsp=local+12;
	w=(pointer)ADD1(ctx,1,local+11); /*1+*/
	local[9] = w;
	goto WHL214;
WHX215:
	local[11]= NIL;
BLK216:
	w = NIL;
	local[9]= w;
	goto IF212;
IF211:
	local[9]= NIL;
IF212:
	local[9]= local[7];
	local[10]= local[1];
	local[11]= local[1];
	ctx->vsp=local+12;
	w=(pointer)MATTIMES(ctx,3,local+9); /*m**/
	local[9]= w;
	local[10]= local[5];
	local[11]= local[2];
	ctx->vsp=local+12;
	w=(pointer)TRANSPOSE(ctx,2,local+10); /*transpose*/
	local[10]= w;
	local[11]= local[0];
	ctx->vsp=local+12;
	w=(pointer)MATTIMES(ctx,3,local+9); /*m**/
	local[0] = w;
	w = local[0];
	local[0]= w;
BLK198:
	ctx->vsp=local; return(local[0]);}

/*sr-inverse*/
static pointer F83sr_inverse(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<1) maerror();
	if (n>=2) { local[0]=(argv[1]); goto ENT231;}
	local[0]= makeflt(1.0000000000000000000000e+00);
ENT231:
	if (n>=3) { local[1]=(argv[2]); goto ENT230;}
	local[1]= NIL;
ENT230:
	if (n>=4) { local[2]=(argv[3]); goto ENT229;}
	local[2]= NIL;
ENT229:
	if (n>=5) { local[3]=(argv[4]); goto ENT228;}
	local[3]= NIL;
ENT228:
	if (n>=6) { local[4]=(argv[5]); goto ENT227;}
	local[4]= NIL;
ENT227:
	if (n>=7) { local[5]=(argv[6]); goto ENT226;}
	local[5]= NIL;
ENT226:
	if (n>=8) { local[6]=(argv[7]); goto ENT225;}
	local[6]= NIL;
ENT225:
	if (n>=9) { local[7]=(argv[8]); goto ENT224;}
	local[7]= NIL;
ENT224:
	if (n>=10) { local[8]=(argv[9]); goto ENT223;}
	local[8]= NIL;
ENT223:
	if (n>=11) { local[9]=(argv[10]); goto ENT222;}
	local[9]= NIL;
ENT222:
	if (n>=12) { local[10]=(argv[11]); goto ENT221;}
	local[10]= NIL;
ENT221:
ENT220:
	if (n>12) maerror();
	local[11]= argv[0];
	local[12]= makeint((eusinteger_t)0L);
	ctx->vsp=local+13;
	w=(*ftab[0])(ctx,2,local+11,&ftab[0],fqv[0]); /*array-dimension*/
	local[11]= w;
	local[12]= argv[0];
	local[13]= makeint((eusinteger_t)1L);
	ctx->vsp=local+14;
	w=(*ftab[0])(ctx,2,local+12,&ftab[0],fqv[0]); /*array-dimension*/
	local[12]= w;
	if (local[4]!=NIL) goto IF232;
	local[13]= local[12];
	local[14]= local[11];
	ctx->vsp=local+15;
	w=(*ftab[3])(ctx,2,local+13,&ftab[3],fqv[3]); /*make-matrix*/
	local[4] = w;
	local[13]= local[4];
	goto IF233;
IF232:
	local[13]= NIL;
IF233:
	if (local[1]!=NIL) goto IF234;
	if (local[9]!=NIL) goto IF236;
	local[13]= local[11];
	local[14]= local[11];
	ctx->vsp=local+15;
	w=(*ftab[3])(ctx,2,local+13,&ftab[3],fqv[3]); /*make-matrix*/
	local[9] = w;
	local[13]= local[9];
	goto IF237;
IF236:
	local[13]= NIL;
IF237:
	if (local[10]!=NIL) goto IF238;
	local[13]= local[11];
	local[14]= local[11];
	ctx->vsp=local+15;
	w=(*ftab[3])(ctx,2,local+13,&ftab[3],fqv[3]); /*make-matrix*/
	local[10] = w;
	local[13]= local[10];
	goto IF239;
IF238:
	local[13]= NIL;
IF239:
	local[13]= argv[0];
	local[14]= local[0];
	local[15]= local[9];
	local[16]= local[4];
	local[17]= local[10];
	ctx->vsp=local+18;
	w=(pointer)F84sr_inverse_org(ctx,5,local+13); /*sr-inverse-org*/
	ctx->vsp=local+13;
	local[0]=w;
	goto BLK219;
	goto IF235;
IF234:
	local[13]= NIL;
IF235:
	if (local[2]!=NIL) goto IF240;
	local[13]= local[12];
	local[14]= local[11];
	ctx->vsp=local+15;
	w=(*ftab[3])(ctx,2,local+13,&ftab[3],fqv[3]); /*make-matrix*/
	local[2] = w;
	local[13]= local[2];
	goto IF241;
IF240:
	local[13]= NIL;
IF241:
	if (local[3]!=NIL) goto IF242;
	local[13]= local[12];
	local[14]= local[12];
	ctx->vsp=local+15;
	w=(*ftab[3])(ctx,2,local+13,&ftab[3],fqv[3]); /*make-matrix*/
	local[3] = w;
	local[13]= local[3];
	goto IF243;
IF242:
	local[13]= NIL;
IF243:
	if (local[8]!=NIL) goto IF244;
	local[13]= local[11];
	local[14]= local[12];
	ctx->vsp=local+15;
	w=(*ftab[3])(ctx,2,local+13,&ftab[3],fqv[3]); /*make-matrix*/
	local[8] = w;
	local[13]= local[8];
	goto IF245;
IF244:
	local[13]= NIL;
IF245:
	local[13]= local[0];
	local[14]= makeflt(0.0000000000000000000000e+00);
	ctx->vsp=local+15;
	w=(pointer)NUMEQUAL(ctx,2,local+13); /*=*/
	if (w==NIL) goto IF246;
	local[13]= argv[0];
	local[14]= local[1];
	local[15]= local[2];
	local[16]= local[3];
	local[17]= local[8];
	ctx->vsp=local+18;
	w=(pointer)F81pseudo_inverse(ctx,5,local+13); /*pseudo-inverse*/
	ctx->vsp=local+13;
	local[0]=w;
	goto BLK219;
	goto IF247;
IF246:
	local[13]= NIL;
IF247:
	if (local[5]!=NIL) goto IF248;
	local[13]= local[11];
	ctx->vsp=local+14;
	w=(*ftab[1])(ctx,1,local+13,&ftab[1],fqv[1]); /*unit-matrix*/
	local[5] = w;
	local[13]= local[5];
	goto IF249;
IF248:
	local[13]= local[5]->c.obj.iv[1];
	local[14]= makeint((eusinteger_t)0L);
	ctx->vsp=local+15;
	w=(*ftab[15])(ctx,2,local+13,&ftab[15],fqv[21]); /*fill*/
	local[13]= makeint((eusinteger_t)0L);
	local[14]= local[11];
WHL251:
	local[15]= local[13];
	w = local[14];
	if ((eusinteger_t)local[15] >= (eusinteger_t)w) goto WHX252;
	local[15]= local[5];
	local[16]= local[13];
	local[17]= local[13];
	local[18]= makeflt(1.0000000000000000000000e+00);
	ctx->vsp=local+19;
	w=(pointer)ASET(ctx,4,local+15); /*aset*/
	local[15]= local[13];
	ctx->vsp=local+16;
	w=(pointer)ADD1(ctx,1,local+15); /*1+*/
	local[13] = w;
	goto WHL251;
WHX252:
	local[15]= NIL;
BLK253:
	w = NIL;
	local[13]= w;
IF249:
	if (local[6]!=NIL) goto IF254;
	local[13]= local[11];
	local[14]= local[11];
	ctx->vsp=local+15;
	w=(*ftab[3])(ctx,2,local+13,&ftab[3],fqv[3]); /*make-matrix*/
	local[6] = w;
	local[13]= local[6];
	goto IF255;
IF254:
	local[13]= NIL;
IF255:
	if (local[7]!=NIL) goto IF256;
	local[13]= local[12];
	local[14]= local[11];
	ctx->vsp=local+15;
	w=(*ftab[3])(ctx,2,local+13,&ftab[3],fqv[3]); /*make-matrix*/
	local[7] = w;
	local[13]= local[7];
	goto IF257;
IF256:
	local[13]= NIL;
IF257:
	local[13]= makeint((eusinteger_t)0L);
	local[14]= local[12];
WHL259:
	local[15]= local[13];
	w = local[14];
	if ((eusinteger_t)local[15] >= (eusinteger_t)w) goto WHX260;
	local[15]= local[3];
	local[16]= local[13];
	local[17]= local[13];
	local[18]= local[1];
	local[19]= local[13];
	ctx->vsp=local+20;
	w=(pointer)AREF(ctx,2,local+18); /*aref*/
	local[18]= w;
	ctx->vsp=local+19;
	w=(pointer)ASET(ctx,4,local+15); /*aset*/
	local[15]= local[13];
	ctx->vsp=local+16;
	w=(pointer)ADD1(ctx,1,local+15); /*1+*/
	local[13] = w;
	goto WHL259;
WHX260:
	local[15]= NIL;
BLK261:
	w = NIL;
	local[13]= local[3];
	local[14]= argv[0];
	local[15]= local[4];
	ctx->vsp=local+16;
	w=(pointer)TRANSPOSE(ctx,2,local+14); /*transpose*/
	local[14]= w;
	local[15]= local[7];
	ctx->vsp=local+16;
	w=(pointer)MATTIMES(ctx,3,local+13); /*m**/
	local[13]= w;
	local[14]= argv[0];
	local[15]= local[7];
	local[16]= local[6];
	ctx->vsp=local+17;
	w=(pointer)MATTIMES(ctx,3,local+14); /*m**/
	local[14]= w;
	local[15]= local[0];
	local[16]= local[5];
	local[17]= local[5];
	ctx->vsp=local+18;
	w=(*ftab[7])(ctx,3,local+15,&ftab[7],fqv[9]); /*scale-matrix*/
	local[15]= w;
	local[16]= local[5];
	ctx->vsp=local+17;
	w=(*ftab[10])(ctx,3,local+14,&ftab[10],fqv[13]); /*m+*/
	local[14]= w;
	ctx->vsp=local+15;
	w=(pointer)F69inverse_matrix(ctx,1,local+14); /*inverse-matrix*/
	local[14]= w;
	local[15]= local[2];
	ctx->vsp=local+16;
	w=(pointer)MATTIMES(ctx,3,local+13); /*m**/
	w = local[2];
	local[0]= w;
BLK219:
	ctx->vsp=local; return(local[0]);}

/*sr-inverse-org*/
static pointer F84sr_inverse_org(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<1) maerror();
	if (n>=2) { local[0]=(argv[1]); goto ENT267;}
	local[0]= makeint((eusinteger_t)1L);
ENT267:
	if (n>=3) { local[1]=(argv[2]); goto ENT266;}
	local[1]= NIL;
ENT266:
	if (n>=4) { local[2]=(argv[3]); goto ENT265;}
	local[2]= NIL;
ENT265:
	if (n>=5) { local[3]=(argv[4]); goto ENT264;}
	local[3]= NIL;
ENT264:
ENT263:
	if (n>5) maerror();
	local[4]= argv[0];
	ctx->vsp=local+5;
	w=(*ftab[6])(ctx,1,local+4,&ftab[6],fqv[8]); /*array-dimensions*/
	local[4]= w;
	w=local[4];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[5]= (w)->c.cons.car;
	w=local[4];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	w=(w)->c.cons.cdr;
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[6]= (w)->c.cons.car;
	if (local[1]!=NIL) goto IF268;
	local[7]= local[5];
	ctx->vsp=local+8;
	w=(*ftab[1])(ctx,1,local+7,&ftab[1],fqv[1]); /*unit-matrix*/
	local[1] = w;
	local[7]= local[1];
	goto IF269;
IF268:
	local[7]= local[1]->c.obj.iv[1];
	local[8]= makeint((eusinteger_t)0L);
	ctx->vsp=local+9;
	w=(*ftab[15])(ctx,2,local+7,&ftab[15],fqv[21]); /*fill*/
	local[7]= makeint((eusinteger_t)0L);
	local[8]= local[5];
WHL271:
	local[9]= local[7];
	w = local[8];
	if ((eusinteger_t)local[9] >= (eusinteger_t)w) goto WHX272;
	local[9]= local[1];
	local[10]= local[7];
	local[11]= local[7];
	local[12]= makeflt(1.0000000000000000000000e+00);
	ctx->vsp=local+13;
	w=(pointer)ASET(ctx,4,local+9); /*aset*/
	local[9]= local[7];
	ctx->vsp=local+10;
	w=(pointer)ADD1(ctx,1,local+9); /*1+*/
	local[7] = w;
	goto WHL271;
WHX272:
	local[9]= NIL;
BLK273:
	w = NIL;
	local[7]= w;
IF269:
	if (local[2]!=NIL) goto IF274;
	local[7]= local[6];
	local[8]= local[5];
	ctx->vsp=local+9;
	w=(*ftab[3])(ctx,2,local+7,&ftab[3],fqv[3]); /*make-matrix*/
	local[2] = w;
	local[7]= local[2];
	goto IF275;
IF274:
	local[7]= NIL;
IF275:
	if (local[3]!=NIL) goto IF276;
	local[7]= local[5];
	local[8]= local[5];
	ctx->vsp=local+9;
	w=(*ftab[3])(ctx,2,local+7,&ftab[3],fqv[3]); /*make-matrix*/
	local[3] = w;
	local[7]= local[3];
	goto IF277;
IF276:
	local[7]= NIL;
IF277:
	local[7]= argv[0];
	local[8]= local[2];
	ctx->vsp=local+9;
	w=(pointer)TRANSPOSE(ctx,2,local+7); /*transpose*/
	local[2] = w;
	local[7]= local[2];
	local[8]= argv[0];
	local[9]= local[2];
	local[10]= local[3];
	ctx->vsp=local+11;
	w=(pointer)MATTIMES(ctx,3,local+8); /*m**/
	local[8]= w;
	local[9]= local[0];
	local[10]= local[1];
	local[11]= local[1];
	ctx->vsp=local+12;
	w=(*ftab[7])(ctx,3,local+9,&ftab[7],fqv[9]); /*scale-matrix*/
	local[9]= w;
	local[10]= local[3];
	ctx->vsp=local+11;
	w=(*ftab[10])(ctx,3,local+8,&ftab[10],fqv[13]); /*m+*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)F69inverse_matrix(ctx,1,local+8); /*inverse-matrix*/
	local[8]= w;
	local[9]= local[2];
	ctx->vsp=local+10;
	w=(pointer)MATTIMES(ctx,3,local+7); /*m**/
	local[0]= w;
BLK262:
	ctx->vsp=local; return(local[0]);}

/*manipulability*/
static pointer F85manipulability(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<1) maerror();
	if (n>=2) { local[0]=(argv[1]); goto ENT281;}
	local[0]= NIL;
ENT281:
	if (n>=3) { local[1]=(argv[2]); goto ENT280;}
	local[1]= NIL;
ENT280:
ENT279:
	if (n>3) maerror();
	local[2]= argv[0];
	local[3]= makeint((eusinteger_t)0L);
	ctx->vsp=local+4;
	w=(*ftab[0])(ctx,2,local+2,&ftab[0],fqv[0]); /*array-dimension*/
	local[2]= w;
	local[3]= argv[0];
	local[4]= makeint((eusinteger_t)1L);
	ctx->vsp=local+5;
	w=(*ftab[0])(ctx,2,local+3,&ftab[0],fqv[0]); /*array-dimension*/
	local[3]= w;
	if (local[0]!=NIL) goto IF282;
	local[4]= local[2];
	local[5]= local[2];
	ctx->vsp=local+6;
	w=(*ftab[3])(ctx,2,local+4,&ftab[3],fqv[3]); /*make-matrix*/
	local[0] = w;
	local[4]= local[0];
	goto IF283;
IF282:
	local[4]= NIL;
IF283:
	if (local[1]!=NIL) goto IF284;
	local[4]= local[3];
	local[5]= local[2];
	ctx->vsp=local+6;
	w=(*ftab[3])(ctx,2,local+4,&ftab[3],fqv[3]); /*make-matrix*/
	local[1] = w;
	local[4]= local[1];
	goto IF285;
IF284:
	local[4]= NIL;
IF285:
	local[4]= makeflt(0.0000000000000000000000e+00);
	local[5]= argv[0];
	local[6]= argv[0];
	local[7]= local[1];
	ctx->vsp=local+8;
	w=(pointer)TRANSPOSE(ctx,2,local+6); /*transpose*/
	local[6]= w;
	local[7]= local[0];
	ctx->vsp=local+8;
	w=(pointer)MATTIMES(ctx,3,local+5); /*m**/
	local[5]= w;
	ctx->vsp=local+6;
	w=(*ftab[8])(ctx,1,local+5,&ftab[8],fqv[10]); /*matrix-determinant*/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)MAX(ctx,2,local+4); /*max*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)SQRT(ctx,1,local+4); /*sqrt*/
	local[0]= w;
BLK278:
	ctx->vsp=local; return(local[0]);}

/*random-gauss*/
static pointer F86random_gauss(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<0) maerror();
	if (n>=1) { local[0]=(argv[0]); goto ENT289;}
	local[0]= makeint((eusinteger_t)0L);
ENT289:
	if (n>=2) { local[1]=(argv[1]); goto ENT288;}
	local[1]= makeint((eusinteger_t)1L);
ENT288:
ENT287:
	if (n>2) maerror();
	local[2]= makeflt(1.0000000000000000000000e+00);
	ctx->vsp=local+3;
	w=(pointer)RANDOM(ctx,1,local+2); /*random*/
	local[2]= w;
	local[3]= makeflt(1.0000000000000000000000e+00);
	ctx->vsp=local+4;
	w=(pointer)RANDOM(ctx,1,local+3); /*random*/
	local[3]= w;
	local[4]= makeflt(-2.0000000000000000000000e+00);
	local[5]= local[1];
	local[6]= local[1];
	local[7]= local[2];
	ctx->vsp=local+8;
	w=(pointer)LOG(ctx,1,local+7); /*log*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(pointer)TIMES(ctx,4,local+4); /***/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)SQRT(ctx,1,local+4); /*sqrt*/
	local[4]= w;
	local[5]= makeint((eusinteger_t)2L);
	local[6]= makeflt(3.1415926535897931159980e+00);
	local[7]= local[3];
	ctx->vsp=local+8;
	w=(pointer)TIMES(ctx,3,local+5); /***/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)COS(ctx,1,local+5); /*cos*/
	{ double x,y;
		y=fltval(w); x=fltval(local[4]);
		local[4]=(makeflt(x * y));}
	local[5]= local[0];
	ctx->vsp=local+6;
	w=(pointer)PLUS(ctx,2,local+4); /*+*/
	local[0]= w;
BLK286:
	ctx->vsp=local; return(local[0]);}

/*gaussian-random*/
static pointer F87gaussian_random(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<1) maerror();
	if (n>=2) { local[0]=(argv[1]); goto ENT293;}
	local[0]= makeint((eusinteger_t)0L);
ENT293:
	if (n>=3) { local[1]=(argv[2]); goto ENT292;}
	local[1]= makeint((eusinteger_t)1L);
ENT292:
ENT291:
	if (n>3) maerror();
	local[2]= loadglobal(fqv[4]);
	local[3]= argv[0];
	ctx->vsp=local+4;
	w=(pointer)INSTANTIATE(ctx,2,local+2); /*instantiate*/
	local[2]= w;
	w = local[0];
	if (!isnum(w)) goto IF294;
	local[3]= argv[0];
	local[4]= fqv[22];
	local[5]= local[0];
	ctx->vsp=local+6;
	w=(*ftab[16])(ctx,3,local+3,&ftab[16],fqv[23]); /*make-list*/
	local[0] = w;
	local[3]= local[0];
	goto IF295;
IF294:
	local[3]= NIL;
IF295:
	w = local[1];
	if (!isnum(w)) goto IF296;
	local[3]= argv[0];
	local[4]= fqv[22];
	local[5]= local[1];
	ctx->vsp=local+6;
	w=(*ftab[16])(ctx,3,local+3,&ftab[16],fqv[23]); /*make-list*/
	local[1] = w;
	local[3]= local[1];
	goto IF297;
IF296:
	local[3]= NIL;
IF297:
	local[3]= makeint((eusinteger_t)0L);
	local[4]= argv[0];
WHL299:
	local[5]= local[3];
	w = local[4];
	if ((eusinteger_t)local[5] >= (eusinteger_t)w) goto WHX300;
	local[5]= local[2];
	local[6]= local[3];
	local[7]= local[0];
	local[8]= local[3];
	ctx->vsp=local+9;
	w=(pointer)ELT(ctx,2,local+7); /*elt*/
	local[7]= w;
	local[8]= local[1];
	local[9]= local[3];
	ctx->vsp=local+10;
	w=(pointer)ELT(ctx,2,local+8); /*elt*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)F86random_gauss(ctx,2,local+7); /*random-gauss*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(pointer)ASET(ctx,3,local+5); /*aset*/
	local[5]= local[3];
	ctx->vsp=local+6;
	w=(pointer)ADD1(ctx,1,local+5); /*1+*/
	local[3] = w;
	goto WHL299;
WHX300:
	local[5]= NIL;
BLK301:
	w = NIL;
	w = local[2];
	local[0]= w;
BLK290:
	ctx->vsp=local; return(local[0]);}

/*eigen-decompose*/
static pointer F88eigen_decompose(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	local[0]= argv[0];
	ctx->vsp=local+1;
	w=(*ftab[17])(ctx,1,local+0,&ftab[17],fqv[24]); /*qr-decompose*/
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[0]= (w)->c.cons.car;
	local[1]= local[0];
	ctx->vsp=local+2;
	w=(pointer)LENGTH(ctx,1,local+1); /*length*/
	local[1]= w;
	local[2]= local[1];
	local[3]= local[1];
	ctx->vsp=local+4;
	w=(*ftab[3])(ctx,2,local+2,&ftab[3],fqv[3]); /*make-matrix*/
	local[2]= w;
	local[3]= NIL;
	local[4]= NIL;
	local[5]= NIL;
	local[6]= NIL;
	local[7]= NIL;
	local[8]= NIL;
	local[9]= NIL;
	local[10]= NIL;
	local[11]= makeint((eusinteger_t)10L);
	local[12]= NIL;
	local[13]= NIL;
	local[14]= local[0];
	local[15]= (pointer)get_sym_func(fqv[25]);
	ctx->vsp=local+16;
	w=(pointer)SORT(ctx,2,local+14); /*sort*/
	local[0] = w;
	local[14]= makeint((eusinteger_t)0L);
	local[15]= local[1];
WHL304:
	local[16]= local[14];
	w = local[15];
	if ((eusinteger_t)local[16] >= (eusinteger_t)w) goto WHX305;
	local[16]= argv[0];
	local[17]= local[0];
	local[18]= local[14];
	ctx->vsp=local+19;
	w=(pointer)ELT(ctx,2,local+17); /*elt*/
	local[17]= w;
	ctx->vsp=local+18;
	w=(pointer)MINUS(ctx,1,local+17); /*-*/
	local[17]= w;
	local[18]= local[1];
	ctx->vsp=local+19;
	w=(*ftab[1])(ctx,1,local+18,&ftab[1],fqv[1]); /*unit-matrix*/
	local[18]= w;
	ctx->vsp=local+19;
	w=(*ftab[7])(ctx,2,local+17,&ftab[7],fqv[9]); /*scale-matrix*/
	local[17]= w;
	ctx->vsp=local+18;
	w=(*ftab[10])(ctx,2,local+16,&ftab[10],fqv[13]); /*m+*/
	local[3] = w;
	local[16]= local[3];
	ctx->vsp=local+17;
	w=(*ftab[18])(ctx,1,local+16,&ftab[18],fqv[26]); /*copy-matrix*/
	local[4] = w;
	local[16]= local[3];
	ctx->vsp=local+17;
	w=(pointer)LU_DECOMPOSE(ctx,1,local+16); /*lu-decompose*/
	local[7] = w;
	if (local[7]==NIL) goto IF307;
	local[16]= loadglobal(fqv[4]);
	local[17]= local[1];
	ctx->vsp=local+18;
	w=(pointer)INSTANTIATE(ctx,2,local+16); /*instantiate*/
	local[5] = w;
WHL309:
	local[16]= local[5];
	ctx->vsp=local+17;
	w=(pointer)VNORM(ctx,1,local+16); /*norm*/
	local[16]= w;
	local[17]= makeint((eusinteger_t)0L);
	ctx->vsp=local+18;
	w=(*ftab[11])(ctx,2,local+16,&ftab[11],fqv[14]); /*eps=*/
	if (w==NIL) goto WHX310;
	local[16]= makeint((eusinteger_t)0L);
	local[17]= local[1];
WHL313:
	local[18]= local[16];
	w = local[17];
	if ((eusinteger_t)local[18] >= (eusinteger_t)w) goto WHX314;
	local[18]= local[5];
	local[19]= local[16];
	local[20]= makeflt(1.0000000000000000000000e+00);
	ctx->vsp=local+21;
	w=(pointer)RANDOM(ctx,1,local+20); /*random*/
	local[20]= w;
	local[21]= makeflt(5.0000000000000000000000e-01);
	ctx->vsp=local+22;
	w=(pointer)MINUS(ctx,2,local+20); /*-*/
	local[20]= w;
	ctx->vsp=local+21;
	w=(pointer)SETELT(ctx,3,local+18); /*setelt*/
	local[18]= local[16];
	ctx->vsp=local+19;
	w=(pointer)ADD1(ctx,1,local+18); /*1+*/
	local[16] = w;
	goto WHL313;
WHX314:
	local[18]= NIL;
BLK315:
	w = NIL;
	local[16]= local[5];
	ctx->vsp=local+17;
	w=(pointer)F102normalize_vector(ctx,1,local+16); /*normalize-vector*/
	local[5] = w;
	goto WHL309;
WHX310:
	local[16]= NIL;
BLK311:
	local[6] = local[5];
	local[10] = makeint((eusinteger_t)0L);
TAG318:
	local[16]= local[3];
	local[17]= local[7];
	local[18]= local[5];
	ctx->vsp=local+19;
	w=(pointer)LU_SOLVE(ctx,3,local+16); /*lu-solve*/
	local[5] = w;
	local[16]= local[5];
	ctx->vsp=local+17;
	w=(pointer)F102normalize_vector(ctx,1,local+16); /*normalize-vector*/
	local[5] = w;
	local[16]= local[10];
	ctx->vsp=local+17;
	w=(pointer)ADD1(ctx,1,local+16); /*1+*/
	local[10] = w;
	local[16]= local[10];
	local[17]= local[11];
	ctx->vsp=local+18;
	w=(pointer)GREQP(ctx,2,local+16); /*>=*/
	if (w!=NIL) goto OR321;
	local[16]= local[6];
	local[17]= local[5];
	ctx->vsp=local+18;
	w=(pointer)VDISTANCE(ctx,2,local+16); /*distance*/
	local[16]= w;
	local[17]= makeint((eusinteger_t)0L);
	ctx->vsp=local+18;
	w=(*ftab[11])(ctx,2,local+16,&ftab[11],fqv[14]); /*eps=*/
	if (w!=NIL) goto OR321;
	goto IF319;
OR321:
	w = NIL;
	ctx->vsp=local+16;
	local[16]=w;
	goto BLK317;
	goto IF320;
IF319:
	local[16]= NIL;
IF320:
	local[16]= local[10];
	local[17]= local[11];
	local[18]= makeint((eusinteger_t)2L);
	ctx->vsp=local+19;
	w=(pointer)QUOTIENT(ctx,2,local+17); /*/*/
	local[17]= w;
	ctx->vsp=local+18;
	w=(pointer)GREATERP(ctx,2,local+16); /*>*/
	if (w==NIL) goto IF322;
	local[16]= makeflt(1.0000000000000000000000e+00);
	local[17]= local[7];
	local[18]= loadglobal(fqv[4]);
	ctx->vsp=local+19;
	w=(pointer)COERCE(ctx,2,local+17); /*coerce*/
	local[17]= w;
	local[18]= local[3];
	local[19]= local[7];
	local[20]= local[5];
	ctx->vsp=local+21;
	w=(pointer)LU_SOLVE(ctx,3,local+18); /*lu-solve*/
	local[18]= w;
	ctx->vsp=local+19;
	w=(pointer)VINNERPRODUCT(ctx,2,local+17); /*v.*/
	local[17]= w;
	ctx->vsp=local+18;
	w=(pointer)QUOTIENT(ctx,2,local+16); /*/*/
	local[13] = w;
	local[16]= local[0];
	local[17]= local[14];
	local[18]= local[0];
	local[19]= local[14];
	ctx->vsp=local+20;
	w=(pointer)ELT(ctx,2,local+18); /*elt*/
	local[18]= w;
	local[19]= local[13];
	ctx->vsp=local+20;
	w=(pointer)PLUS(ctx,2,local+18); /*+*/
	local[18]= w;
	ctx->vsp=local+19;
	w=(pointer)SETELT(ctx,3,local+16); /*setelt*/
	local[16]= argv[0];
	local[17]= local[0];
	local[18]= local[14];
	ctx->vsp=local+19;
	w=(pointer)ELT(ctx,2,local+17); /*elt*/
	local[17]= w;
	ctx->vsp=local+18;
	w=(pointer)MINUS(ctx,1,local+17); /*-*/
	local[17]= w;
	local[18]= local[1];
	ctx->vsp=local+19;
	w=(*ftab[1])(ctx,1,local+18,&ftab[1],fqv[1]); /*unit-matrix*/
	local[18]= w;
	ctx->vsp=local+19;
	w=(*ftab[7])(ctx,2,local+17,&ftab[7],fqv[9]); /*scale-matrix*/
	local[17]= w;
	ctx->vsp=local+18;
	w=(*ftab[10])(ctx,2,local+16,&ftab[10],fqv[13]); /*m+*/
	local[3] = w;
	local[16]= local[3];
	ctx->vsp=local+17;
	w=(pointer)LU_DECOMPOSE(ctx,1,local+16); /*lu-decompose*/
	local[7] = w;
	if (local[7]!=NIL) goto IF324;
	w = NIL;
	ctx->vsp=local+16;
	local[16]=w;
	goto BLK317;
	goto IF325;
IF324:
	local[16]= NIL;
IF325:
	goto IF323;
IF322:
	local[16]= NIL;
IF323:
	local[6] = local[5];
	ctx->vsp=local+16;
	goto TAG318;
	local[16]= NIL;
BLK317:
	local[16]= local[10];
	local[17]= local[11];
	ctx->vsp=local+18;
	w=(pointer)GREQP(ctx,2,local+16); /*>=*/
	if (w==NIL) goto IF326;
	local[7] = NIL;
	local[16]= local[7];
	goto IF327;
IF326:
	local[16]= NIL;
IF327:
	goto IF308;
IF307:
	local[16]= NIL;
IF308:
	if (local[7]!=NIL) goto IF328;
	local[16]= local[4];
	ctx->vsp=local+17;
	w=(*ftab[14])(ctx,1,local+16,&ftab[14],fqv[19]); /*sv-decompose*/
	local[8] = w;
	local[16]= local[8];
	local[17]= makeint((eusinteger_t)1L);
	ctx->vsp=local+18;
	w=(pointer)ELT(ctx,2,local+16); /*elt*/
	local[9] = w;
	local[16]= makeint((eusinteger_t)0L);
	local[17]= local[9];
	ctx->vsp=local+18;
	w=(pointer)LENGTH(ctx,1,local+17); /*length*/
	local[17]= w;
WHL331:
	local[18]= local[16];
	w = local[17];
	if ((eusinteger_t)local[18] >= (eusinteger_t)w) goto WHX332;
	local[18]= local[9];
	local[19]= local[16];
	ctx->vsp=local+20;
	w=(pointer)ELT(ctx,2,local+18); /*elt*/
	local[18]= w;
	ctx->vsp=local+19;
	w=(pointer)ABS(ctx,1,local+18); /*abs*/
	local[18]= w;
	local[19]= makeflt(9.9999999999999991239646e-05);
	ctx->vsp=local+20;
	w=(pointer)LESSP(ctx,2,local+18); /*<*/
	if (w==NIL) goto IF334;
	local[18]= local[8];
	local[19]= makeint((eusinteger_t)2L);
	ctx->vsp=local+20;
	w=(pointer)ELT(ctx,2,local+18); /*elt*/
	local[18]= w;
	local[19]= local[16];
	ctx->vsp=local+20;
	w=(*ftab[19])(ctx,2,local+18,&ftab[19],fqv[27]); /*matrix-column*/
	local[5] = w;
	local[18]= local[5];
	goto IF335;
IF334:
	local[18]= NIL;
IF335:
	local[18]= local[16];
	ctx->vsp=local+19;
	w=(pointer)ADD1(ctx,1,local+18); /*1+*/
	local[16] = w;
	goto WHL331;
WHX332:
	local[18]= NIL;
BLK333:
	w = NIL;
	local[16]= w;
	goto IF329;
IF328:
	local[16]= NIL;
IF329:
	local[16]= local[2];
	local[17]= local[14];
	local[18]= local[5];
	ctx->vsp=local+19;
	w=(*ftab[20])(ctx,3,local+16,&ftab[20],fqv[28]); /*set-matrix-column*/
	local[16]= local[14];
	ctx->vsp=local+17;
	w=(pointer)ADD1(ctx,1,local+16); /*1+*/
	local[14] = w;
	goto WHL304;
WHX305:
	local[16]= NIL;
BLK306:
	w = NIL;
	local[14]= local[0];
	local[15]= local[2];
	ctx->vsp=local+16;
	w=(pointer)LIST(ctx,2,local+14); /*list*/
	local[0]= w;
BLK302:
	ctx->vsp=local; return(local[0]);}

/*eigen-decompose-complex*/
static pointer F89eigen_decompose_complex(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	local[0]= argv[0];
	ctx->vsp=local+1;
	w=(*ftab[17])(ctx,1,local+0,&ftab[17],fqv[24]); /*qr-decompose*/
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[0]= (w)->c.cons.car;
	local[1]= argv[0];
	ctx->vsp=local+2;
	w=(*ftab[17])(ctx,1,local+1,&ftab[17],fqv[24]); /*qr-decompose*/
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	w=(w)->c.cons.cdr;
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[1]= (w)->c.cons.car;
	local[2]= local[0];
	ctx->vsp=local+3;
	w=(pointer)LENGTH(ctx,1,local+2); /*length*/
	local[2]= w;
	local[3]= local[2];
	ctx->vsp=local+4;
	w=(*ftab[16])(ctx,1,local+3,&ftab[16],fqv[23]); /*make-list*/
	local[3]= w;
	local[4]= local[2];
	local[5]= local[2];
	ctx->vsp=local+6;
	w=(*ftab[3])(ctx,2,local+4,&ftab[3],fqv[3]); /*make-matrix*/
	local[4]= w;
	local[5]= local[2];
	local[6]= local[2];
	ctx->vsp=local+7;
	w=(*ftab[3])(ctx,2,local+5,&ftab[3],fqv[3]); /*make-matrix*/
	local[5]= w;
	local[6]= NIL;
	local[7]= NIL;
	local[8]= NIL;
	local[9]= NIL;
	local[10]= NIL;
	local[11]= NIL;
	local[12]= NIL;
	local[13]= NIL;
	local[14]= NIL;
	local[15]= NIL;
	local[16]= NIL;
	local[17]= makeint((eusinteger_t)0L);
	local[18]= local[2];
WHL338:
	local[19]= local[17];
	w = local[18];
	if ((eusinteger_t)local[19] >= (eusinteger_t)w) goto WHX339;
	local[19]= local[3];
	local[20]= local[17];
	local[21]= local[0];
	local[22]= local[17];
	ctx->vsp=local+23;
	w=(pointer)ELT(ctx,2,local+21); /*elt*/
	local[21]= w;
	local[22]= local[1];
	local[23]= local[17];
	ctx->vsp=local+24;
	w=(pointer)ELT(ctx,2,local+22); /*elt*/
	local[22]= w;
	ctx->vsp=local+23;
	w=(pointer)MKFLTVEC(ctx,2,local+21); /*float-vector*/
	local[21]= w;
	ctx->vsp=local+22;
	w=(pointer)SETELT(ctx,3,local+19); /*setelt*/
	local[19]= local[17];
	ctx->vsp=local+20;
	w=(pointer)ADD1(ctx,1,local+19); /*1+*/
	local[17] = w;
	goto WHL338;
WHX339:
	local[19]= NIL;
BLK340:
	w = NIL;
	local[17]= local[3];
	ctx->vsp=local+18;
	local[18]= makeclosure(codevec,quotevec,CLO341,env,argv,local);
	ctx->vsp=local+19;
	w=(pointer)SORT(ctx,2,local+17); /*sort*/
	local[17]= makeint((eusinteger_t)0L);
	local[18]= local[2];
WHL343:
	local[19]= local[17];
	w = local[18];
	if ((eusinteger_t)local[19] >= (eusinteger_t)w) goto WHX344;
	local[19]= local[3];
	local[20]= local[17];
	ctx->vsp=local+21;
	w=(pointer)ELT(ctx,2,local+19); /*elt*/
	local[6] = w;
	local[19]= local[6];
	local[20]= makeint((eusinteger_t)0L);
	ctx->vsp=local+21;
	w=(pointer)ELT(ctx,2,local+19); /*elt*/
	local[7] = w;
	local[19]= local[6];
	local[20]= makeint((eusinteger_t)1L);
	ctx->vsp=local+21;
	w=(pointer)ELT(ctx,2,local+19); /*elt*/
	local[8] = w;
	local[19]= local[0];
	local[20]= local[17];
	local[21]= local[7];
	ctx->vsp=local+22;
	w=(pointer)SETELT(ctx,3,local+19); /*setelt*/
	local[19]= local[1];
	local[20]= local[17];
	local[21]= local[8];
	ctx->vsp=local+22;
	w=(pointer)SETELT(ctx,3,local+19); /*setelt*/
	local[19]= argv[0];
	local[20]= local[7];
	ctx->vsp=local+21;
	w=(pointer)MINUS(ctx,1,local+20); /*-*/
	local[20]= w;
	local[21]= local[2];
	ctx->vsp=local+22;
	w=(*ftab[1])(ctx,1,local+21,&ftab[1],fqv[1]); /*unit-matrix*/
	local[21]= w;
	ctx->vsp=local+22;
	w=(*ftab[7])(ctx,2,local+20,&ftab[7],fqv[9]); /*scale-matrix*/
	local[20]= w;
	ctx->vsp=local+21;
	w=(*ftab[10])(ctx,2,local+19,&ftab[10],fqv[13]); /*m+*/
	local[9] = w;
	local[19]= local[8];
	local[20]= local[2];
	ctx->vsp=local+21;
	w=(*ftab[1])(ctx,1,local+20,&ftab[1],fqv[1]); /*unit-matrix*/
	local[20]= w;
	ctx->vsp=local+21;
	w=(*ftab[7])(ctx,2,local+19,&ftab[7],fqv[9]); /*scale-matrix*/
	local[10] = w;
	local[19]= local[8];
	ctx->vsp=local+20;
	w=(pointer)MINUS(ctx,1,local+19); /*-*/
	local[19]= w;
	local[20]= local[2];
	ctx->vsp=local+21;
	w=(*ftab[1])(ctx,1,local+20,&ftab[1],fqv[1]); /*unit-matrix*/
	local[20]= w;
	ctx->vsp=local+21;
	w=(*ftab[7])(ctx,2,local+19,&ftab[7],fqv[9]); /*scale-matrix*/
	local[11] = w;
	local[19]= argv[0];
	local[20]= local[7];
	ctx->vsp=local+21;
	w=(pointer)MINUS(ctx,1,local+20); /*-*/
	local[20]= w;
	local[21]= local[2];
	ctx->vsp=local+22;
	w=(*ftab[1])(ctx,1,local+21,&ftab[1],fqv[1]); /*unit-matrix*/
	local[21]= w;
	ctx->vsp=local+22;
	w=(*ftab[7])(ctx,2,local+20,&ftab[7],fqv[9]); /*scale-matrix*/
	local[20]= w;
	ctx->vsp=local+21;
	w=(*ftab[10])(ctx,2,local+19,&ftab[10],fqv[13]); /*m+*/
	local[12] = w;
	local[19]= local[9];
	local[20]= local[10];
	ctx->vsp=local+21;
	w=(pointer)F98concatenate_matrix_row(ctx,2,local+19); /*concatenate-matrix-row*/
	local[19]= w;
	local[20]= local[11];
	local[21]= local[12];
	ctx->vsp=local+22;
	w=(pointer)F98concatenate_matrix_row(ctx,2,local+20); /*concatenate-matrix-row*/
	local[20]= w;
	ctx->vsp=local+21;
	w=(pointer)F97concatenate_matrix_column(ctx,2,local+19); /*concatenate-matrix-column*/
	local[13] = w;
	local[19]= local[13];
	ctx->vsp=local+20;
	w=(pointer)F90solve_non_zero_vector_from_det0_matrix(ctx,1,local+19); /*solve-non-zero-vector-from-det0-matrix*/
	local[14] = w;
	local[19]= local[2];
	ctx->vsp=local+20;
	w=(*ftab[1])(ctx,1,local+19,&ftab[1],fqv[1]); /*unit-matrix*/
	local[19]= w;
	local[20]= local[2];
	local[21]= local[2];
	ctx->vsp=local+22;
	w=(*ftab[3])(ctx,2,local+20,&ftab[3],fqv[3]); /*make-matrix*/
	local[20]= w;
	ctx->vsp=local+21;
	w=(pointer)F98concatenate_matrix_row(ctx,2,local+19); /*concatenate-matrix-row*/
	local[19]= w;
	local[20]= local[14];
	ctx->vsp=local+21;
	w=(pointer)TRANSFORM(ctx,2,local+19); /*transform*/
	local[15] = w;
	local[19]= local[2];
	local[20]= local[2];
	ctx->vsp=local+21;
	w=(*ftab[3])(ctx,2,local+19,&ftab[3],fqv[3]); /*make-matrix*/
	local[19]= w;
	local[20]= local[2];
	ctx->vsp=local+21;
	w=(*ftab[1])(ctx,1,local+20,&ftab[1],fqv[1]); /*unit-matrix*/
	local[20]= w;
	ctx->vsp=local+21;
	w=(pointer)F98concatenate_matrix_row(ctx,2,local+19); /*concatenate-matrix-row*/
	local[19]= w;
	local[20]= local[14];
	ctx->vsp=local+21;
	w=(pointer)TRANSFORM(ctx,2,local+19); /*transform*/
	local[16] = w;
	local[19]= local[4];
	local[20]= local[17];
	local[21]= local[15];
	ctx->vsp=local+22;
	w=(*ftab[20])(ctx,3,local+19,&ftab[20],fqv[28]); /*set-matrix-column*/
	local[19]= local[5];
	local[20]= local[17];
	local[21]= local[16];
	ctx->vsp=local+22;
	w=(*ftab[20])(ctx,3,local+19,&ftab[20],fqv[28]); /*set-matrix-column*/
	local[19]= local[17];
	ctx->vsp=local+20;
	w=(pointer)ADD1(ctx,1,local+19); /*1+*/
	local[17] = w;
	goto WHL343;
WHX344:
	local[19]= NIL;
BLK345:
	w = NIL;
	local[17]= local[0];
	local[18]= local[1];
	ctx->vsp=local+19;
	w=(pointer)LIST(ctx,2,local+17); /*list*/
	local[17]= w;
	local[18]= local[4];
	local[19]= local[5];
	ctx->vsp=local+20;
	w=(pointer)LIST(ctx,2,local+18); /*list*/
	local[18]= w;
	ctx->vsp=local+19;
	w=(pointer)LIST(ctx,2,local+17); /*list*/
	local[0]= w;
BLK336:
	ctx->vsp=local; return(local[0]);}

/*closure or cleaner*/
static pointer CLO341(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=2) maerror();
	local[0]= argv[0];
	local[1]= makeint((eusinteger_t)0L);
	ctx->vsp=local+2;
	w=(pointer)ELT(ctx,2,local+0); /*elt*/
	local[0]= w;
	local[1]= argv[1];
	local[2]= makeint((eusinteger_t)0L);
	ctx->vsp=local+3;
	w=(pointer)ELT(ctx,2,local+1); /*elt*/
	local[1]= w;
	ctx->vsp=local+2;
	w=(pointer)GREATERP(ctx,2,local+0); /*>*/
	local[0]= w;
	ctx->vsp=local; return(local[0]);}

/*solve-non-zero-vector-from-det0-matrix*/
static pointer F90solve_non_zero_vector_from_det0_matrix(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	local[0]= argv[0];
	ctx->vsp=local+1;
	w=(*ftab[8])(ctx,1,local+0,&ftab[8],fqv[10]); /*matrix-determinant*/
	local[0]= w;
	local[1]= makeint((eusinteger_t)0L);
	ctx->vsp=local+2;
	w=(*ftab[11])(ctx,2,local+0,&ftab[11],fqv[14]); /*eps=*/
	if (w!=NIL) goto IF347;
	local[0]= fqv[29];
	ctx->vsp=local+1;
	w=(*ftab[4])(ctx,1,local+0,&ftab[4],fqv[6]); /*warn*/
	w = NIL;
	ctx->vsp=local+0;
	local[0]=w;
	goto BLK346;
	goto IF348;
IF347:
	local[0]= NIL;
IF348:
	local[0]= argv[0];
	ctx->vsp=local+1;
	w=(*ftab[6])(ctx,1,local+0,&ftab[6],fqv[8]); /*array-dimensions*/
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[0]= (w)->c.cons.car;
	local[1]= NIL;
	local[2]= NIL;
	local[3]= NIL;
	local[4]= NIL;
	local[5]= NIL;
	local[6]= NIL;
	local[7]= NIL;
	local[8]= NIL;
	local[9]= makeint((eusinteger_t)10L);
	local[1] = argv[0];
	local[10]= local[1];
	ctx->vsp=local+11;
	w=(*ftab[18])(ctx,1,local+10,&ftab[18],fqv[26]); /*copy-matrix*/
	local[2] = w;
	local[10]= local[1];
	ctx->vsp=local+11;
	w=(pointer)LU_DECOMPOSE(ctx,1,local+10); /*lu-decompose*/
	local[5] = w;
	if (local[5]==NIL) goto IF349;
	local[10]= loadglobal(fqv[4]);
	local[11]= local[0];
	ctx->vsp=local+12;
	w=(pointer)INSTANTIATE(ctx,2,local+10); /*instantiate*/
	local[3] = w;
WHL351:
	local[10]= local[3];
	ctx->vsp=local+11;
	w=(pointer)VNORM(ctx,1,local+10); /*norm*/
	local[10]= w;
	local[11]= makeint((eusinteger_t)0L);
	ctx->vsp=local+12;
	w=(*ftab[11])(ctx,2,local+10,&ftab[11],fqv[14]); /*eps=*/
	if (w==NIL) goto WHX352;
	local[10]= makeint((eusinteger_t)0L);
	local[11]= local[0];
WHL355:
	local[12]= local[10];
	w = local[11];
	if ((eusinteger_t)local[12] >= (eusinteger_t)w) goto WHX356;
	local[12]= local[3];
	local[13]= local[10];
	local[14]= makeflt(1.0000000000000000000000e+00);
	ctx->vsp=local+15;
	w=(pointer)RANDOM(ctx,1,local+14); /*random*/
	local[14]= w;
	local[15]= makeflt(5.0000000000000000000000e-01);
	ctx->vsp=local+16;
	w=(pointer)MINUS(ctx,2,local+14); /*-*/
	local[14]= w;
	ctx->vsp=local+15;
	w=(pointer)SETELT(ctx,3,local+12); /*setelt*/
	local[12]= local[10];
	ctx->vsp=local+13;
	w=(pointer)ADD1(ctx,1,local+12); /*1+*/
	local[10] = w;
	goto WHL355;
WHX356:
	local[12]= NIL;
BLK357:
	w = NIL;
	local[10]= local[3];
	ctx->vsp=local+11;
	w=(pointer)F102normalize_vector(ctx,1,local+10); /*normalize-vector*/
	local[3] = w;
	goto WHL351;
WHX352:
	local[10]= NIL;
BLK353:
	local[4] = local[3];
	local[8] = makeint((eusinteger_t)0L);
TAG360:
	local[10]= local[1];
	local[11]= local[5];
	local[12]= local[3];
	ctx->vsp=local+13;
	w=(pointer)LU_SOLVE(ctx,3,local+10); /*lu-solve*/
	local[3] = w;
	local[10]= local[3];
	ctx->vsp=local+11;
	w=(pointer)F102normalize_vector(ctx,1,local+10); /*normalize-vector*/
	local[3] = w;
	local[10]= local[8];
	ctx->vsp=local+11;
	w=(pointer)ADD1(ctx,1,local+10); /*1+*/
	local[8] = w;
	local[10]= local[8];
	local[11]= local[9];
	ctx->vsp=local+12;
	w=(pointer)GREQP(ctx,2,local+10); /*>=*/
	if (w!=NIL) goto OR363;
	local[10]= local[4];
	local[11]= local[3];
	ctx->vsp=local+12;
	w=(pointer)VDISTANCE(ctx,2,local+10); /*distance*/
	local[10]= w;
	local[11]= makeint((eusinteger_t)0L);
	ctx->vsp=local+12;
	w=(*ftab[11])(ctx,2,local+10,&ftab[11],fqv[14]); /*eps=*/
	if (w!=NIL) goto OR363;
	goto IF361;
OR363:
	w = NIL;
	ctx->vsp=local+10;
	local[10]=w;
	goto BLK359;
	goto IF362;
IF361:
	local[10]= NIL;
IF362:
	local[10]= local[8];
	local[11]= local[9];
	local[12]= makeint((eusinteger_t)2L);
	ctx->vsp=local+13;
	w=(pointer)QUOTIENT(ctx,2,local+11); /*/*/
	local[11]= w;
	ctx->vsp=local+12;
	w=(pointer)GREATERP(ctx,2,local+10); /*>*/
	if (w==NIL) goto IF364;
	local[1] = argv[0];
	local[10]= local[1];
	ctx->vsp=local+11;
	w=(pointer)LU_DECOMPOSE(ctx,1,local+10); /*lu-decompose*/
	local[5] = w;
	if (local[5]!=NIL) goto IF366;
	w = NIL;
	ctx->vsp=local+10;
	local[10]=w;
	goto BLK359;
	goto IF367;
IF366:
	local[10]= NIL;
IF367:
	goto IF365;
IF364:
	local[10]= NIL;
IF365:
	local[4] = local[3];
	ctx->vsp=local+10;
	goto TAG360;
	local[10]= NIL;
BLK359:
	local[10]= local[8];
	local[11]= local[9];
	ctx->vsp=local+12;
	w=(pointer)GREQP(ctx,2,local+10); /*>=*/
	if (w==NIL) goto IF368;
	local[5] = NIL;
	local[10]= local[5];
	goto IF369;
IF368:
	local[10]= NIL;
IF369:
	goto IF350;
IF349:
	local[10]= NIL;
IF350:
	if (local[5]!=NIL) goto IF370;
	local[10]= local[2];
	ctx->vsp=local+11;
	w=(*ftab[14])(ctx,1,local+10,&ftab[14],fqv[19]); /*sv-decompose*/
	local[6] = w;
	local[10]= local[6];
	local[11]= makeint((eusinteger_t)1L);
	ctx->vsp=local+12;
	w=(pointer)ELT(ctx,2,local+10); /*elt*/
	local[7] = w;
	local[10]= makeint((eusinteger_t)0L);
	local[11]= local[7];
	ctx->vsp=local+12;
	w=(pointer)LENGTH(ctx,1,local+11); /*length*/
	local[11]= w;
WHL373:
	local[12]= local[10];
	w = local[11];
	if ((eusinteger_t)local[12] >= (eusinteger_t)w) goto WHX374;
	local[12]= local[7];
	local[13]= local[10];
	ctx->vsp=local+14;
	w=(pointer)ELT(ctx,2,local+12); /*elt*/
	local[12]= w;
	ctx->vsp=local+13;
	w=(pointer)ABS(ctx,1,local+12); /*abs*/
	local[12]= w;
	local[13]= makeflt(9.9999999999999991239646e-05);
	ctx->vsp=local+14;
	w=(pointer)LESSP(ctx,2,local+12); /*<*/
	if (w==NIL) goto IF376;
	local[12]= local[6];
	local[13]= makeint((eusinteger_t)2L);
	ctx->vsp=local+14;
	w=(pointer)ELT(ctx,2,local+12); /*elt*/
	local[12]= w;
	local[13]= local[10];
	ctx->vsp=local+14;
	w=(*ftab[19])(ctx,2,local+12,&ftab[19],fqv[27]); /*matrix-column*/
	local[3] = w;
	local[12]= local[3];
	goto IF377;
IF376:
	local[12]= NIL;
IF377:
	local[12]= local[10];
	ctx->vsp=local+13;
	w=(pointer)ADD1(ctx,1,local+12); /*1+*/
	local[10] = w;
	goto WHL373;
WHX374:
	local[12]= NIL;
BLK375:
	w = NIL;
	local[10]= w;
	goto IF371;
IF370:
	local[10]= NIL;
IF371:
	w = local[3];
	local[0]= w;
BLK346:
	ctx->vsp=local; return(local[0]);}

/*lms*/
static pointer F91lms(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	local[0]= argv[0];
	ctx->vsp=local+1;
	w=(*ftab[21])(ctx,1,local+0,&ftab[21],fqv[30]); /*vector-mean*/
	local[0]= w;
	local[1]= argv[0];
	ctx->vsp=local+2;
	w=(pointer)LENGTH(ctx,1,local+1); /*length*/
	local[1]= w;
	local[2]= NIL;
	local[3]= NIL;
	local[4]= NIL;
	local[5]= NIL;
	local[6]= NIL;
	local[7]= NIL;
	local[8]= NIL;
	local[9]= NIL;
	local[10]= local[1];
	local[11]= local[0];
	ctx->vsp=local+12;
	w=(pointer)LENGTH(ctx,1,local+11); /*length*/
	local[11]= w;
	ctx->vsp=local+12;
	w=(*ftab[3])(ctx,2,local+10,&ftab[3],fqv[3]); /*make-matrix*/
	local[3] = w;
	local[10]= makeint((eusinteger_t)0L);
	local[11]= local[1];
WHL380:
	local[12]= local[10];
	w = local[11];
	if ((eusinteger_t)local[12] >= (eusinteger_t)w) goto WHX381;
	local[12]= local[3];
	local[13]= local[10];
	local[14]= argv[0];
	local[15]= local[10];
	ctx->vsp=local+16;
	w=(pointer)ELT(ctx,2,local+14); /*elt*/
	local[14]= w;
	local[15]= local[0];
	ctx->vsp=local+16;
	w=(pointer)VMINUS(ctx,2,local+14); /*v-*/
	local[14]= w;
	ctx->vsp=local+15;
	w=(*ftab[22])(ctx,3,local+12,&ftab[22],fqv[31]); /*set-matrix-row*/
	local[12]= local[10];
	ctx->vsp=local+13;
	w=(pointer)ADD1(ctx,1,local+12); /*1+*/
	local[10] = w;
	goto WHL380;
WHX381:
	local[12]= NIL;
BLK382:
	w = NIL;
	local[10]= makeflt(1.0000000000000000000000e+00);
	local[11]= local[1];
	local[12]= makeint((eusinteger_t)1L);
	ctx->vsp=local+13;
	w=(pointer)MINUS(ctx,2,local+11); /*-*/
	local[11]= w;
	ctx->vsp=local+12;
	w=(pointer)QUOTIENT(ctx,2,local+10); /*/*/
	local[10]= w;
	local[11]= local[3];
	ctx->vsp=local+12;
	w=(pointer)TRANSPOSE(ctx,1,local+11); /*transpose*/
	local[11]= w;
	local[12]= local[3];
	ctx->vsp=local+13;
	w=(pointer)MATTIMES(ctx,2,local+11); /*m**/
	local[11]= w;
	ctx->vsp=local+12;
	w=(*ftab[7])(ctx,2,local+10,&ftab[7],fqv[9]); /*scale-matrix*/
	local[4] = w;
	local[10]= local[4];
	ctx->vsp=local+11;
	w=(pointer)F88eigen_decompose(ctx,1,local+10); /*eigen-decompose*/
	local[5] = w;
	w=local[5];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[6] = (w)->c.cons.car;
	w=local[5];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	w=(w)->c.cons.cdr;
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[7] = (w)->c.cons.car;
	local[10]= local[6];
	local[11]= makeint((eusinteger_t)0L);
	ctx->vsp=local+12;
	w=(pointer)ELT(ctx,2,local+10); /*elt*/
	local[8] = w;
	local[10]= local[7];
	local[11]= makeint((eusinteger_t)0L);
	ctx->vsp=local+12;
	w=(*ftab[19])(ctx,2,local+10,&ftab[19],fqv[27]); /*matrix-column*/
	local[9] = w;
	local[10]= makeint((eusinteger_t)0L);
	local[11]= local[6];
	ctx->vsp=local+12;
	w=(pointer)LENGTH(ctx,1,local+11); /*length*/
	local[11]= w;
WHL384:
	local[12]= local[10];
	w = local[11];
	if ((eusinteger_t)local[12] >= (eusinteger_t)w) goto WHX385;
	local[12]= local[8];
	local[13]= local[6];
	local[14]= local[10];
	ctx->vsp=local+15;
	w=(pointer)ELT(ctx,2,local+13); /*elt*/
	local[13]= w;
	ctx->vsp=local+14;
	w=(pointer)GREATERP(ctx,2,local+12); /*>*/
	if (w==NIL) goto IF387;
	local[12]= local[6];
	local[13]= local[10];
	ctx->vsp=local+14;
	w=(pointer)ELT(ctx,2,local+12); /*elt*/
	local[8] = w;
	local[12]= local[7];
	local[13]= local[10];
	ctx->vsp=local+14;
	w=(*ftab[19])(ctx,2,local+12,&ftab[19],fqv[27]); /*matrix-column*/
	local[9] = w;
	local[12]= local[9];
	goto IF388;
IF387:
	local[12]= NIL;
IF388:
	local[12]= local[10];
	ctx->vsp=local+13;
	w=(pointer)ADD1(ctx,1,local+12); /*1+*/
	local[10] = w;
	goto WHL384;
WHX385:
	local[12]= NIL;
BLK386:
	w = NIL;
	local[10]= local[9];
	local[11]= local[0];
	local[12]= local[9];
	ctx->vsp=local+13;
	w=(pointer)VINNERPRODUCT(ctx,2,local+11); /*v.*/
	local[11]= makeflt(-(fltval(w)));
	ctx->vsp=local+12;
	w=(pointer)LIST(ctx,2,local+10); /*list*/
	local[0]= w;
BLK378:
	ctx->vsp=local; return(local[0]);}

/*lms-estimate*/
static pointer F92lms_estimate(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=2) maerror();
	local[0]= argv[1];
	w=argv[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[1]= (w)->c.cons.car;
	ctx->vsp=local+2;
	w=(pointer)VINNERPRODUCT(ctx,2,local+0); /*v.*/
	local[0]= w;
	w=argv[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	w=(w)->c.cons.cdr;
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[1]= (w)->c.cons.car;
	ctx->vsp=local+2;
	w=(pointer)PLUS(ctx,2,local+0); /*+*/
	local[0]= w;
BLK389:
	ctx->vsp=local; return(local[0]);}

/*lms-error*/
static pointer F93lms_error(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=2) maerror();
	local[0]= makeint((eusinteger_t)0L);
	local[1]= NIL;
	local[2]= NIL;
	local[3]= argv[1];
WHL392:
	if (local[3]==NIL) goto WHX393;
	w=local[3];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[4]= (w)->c.cons.car;
	w=local[3];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[3] = (w)->c.cons.cdr;
	w = local[4];
	local[2] = w;
	local[4]= argv[0];
	local[5]= local[2];
	ctx->vsp=local+6;
	w=(pointer)F92lms_estimate(ctx,2,local+4); /*lms-estimate*/
	local[1] = w;
	local[4]= local[0];
	local[5]= local[1];
	local[6]= local[1];
	ctx->vsp=local+7;
	w=(pointer)TIMES(ctx,2,local+5); /***/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)PLUS(ctx,2,local+4); /*+*/
	local[0] = w;
	goto WHL392;
WHX393:
	local[4]= NIL;
BLK394:
	w = NIL;
	local[2]= local[0];
	local[3]= argv[1];
	ctx->vsp=local+4;
	w=(pointer)LENGTH(ctx,1,local+3); /*length*/
	local[3]= w;
	ctx->vsp=local+4;
	w=(pointer)QUOTIENT(ctx,2,local+2); /*/*/
	local[0]= w;
BLK390:
	ctx->vsp=local; return(local[0]);}

/*lmeds*/
static pointer F94lmeds(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<1) maerror();
	ctx->vsp=local+0;
	n=parsekeyparams(fqv[32], &argv[1], n-1, local+0, 0);
	if (n & (1<<0)) goto KEY397;
	local[0] = makeint((eusinteger_t)5L);
KEY397:
	if (n & (1<<1)) goto KEY398;
	local[1] = makeflt(2.9999999999999982236432e-01);
KEY398:
	if (n & (1<<2)) goto KEY399;
	local[2] = NIL;
KEY399:
	if (n & (1<<3)) goto KEY400;
	local[3] = NIL;
KEY400:
	if (n & (1<<4)) goto KEY401;
	local[4] = (pointer)get_sym_func(fqv[33]);
KEY401:
	if (n & (1<<5)) goto KEY402;
	local[5] = (pointer)get_sym_func(fqv[34]);
KEY402:
	if (n & (1<<6)) goto KEY403;
	local[6] = (pointer)get_sym_func(fqv[35]);
KEY403:
	local[7]= NIL;
	local[8]= NIL;
	local[9]= NIL;
	local[10]= NIL;
	local[11]= NIL;
	local[12]= NIL;
	local[13]= NIL;
	local[14]= NIL;
	local[15]= NIL;
	local[16]= argv[0];
	ctx->vsp=local+17;
	w=(pointer)LENGTH(ctx,1,local+16); /*length*/
	local[7] = w;
	local[16]= makeint((eusinteger_t)2L);
	local[17]= local[0];
	ctx->vsp=local+18;
	w=(pointer)MAX(ctx,2,local+16); /*max*/
	local[16]= w;
	local[17]= local[7];
	ctx->vsp=local+18;
	w=(pointer)MIN(ctx,2,local+16); /*min*/
	local[0] = w;
	local[10] = NIL;
	local[11] = NIL;
	local[15] = NIL;
	if (local[2]==NIL) goto IF404;
	local[12] = local[2];
	local[16]= local[12];
	goto IF405;
IF404:
	local[16]= makeflt(9.9999999999999950039964e-03);
	ctx->vsp=local+17;
	w=(pointer)LOG(ctx,1,local+16); /*log*/
	local[16]= w;
	local[17]= makeint((eusinteger_t)1L);
	local[18]= makeint((eusinteger_t)1L);
	local[19]= local[1];
	ctx->vsp=local+20;
	w=(pointer)MINUS(ctx,2,local+18); /*-*/
	local[18]= w;
	local[19]= local[0];
	ctx->vsp=local+20;
	w=(*ftab[23])(ctx,2,local+18,&ftab[23],fqv[36]); /*expt*/
	local[18]= w;
	ctx->vsp=local+19;
	w=(pointer)MINUS(ctx,2,local+17); /*-*/
	local[17]= w;
	ctx->vsp=local+18;
	w=(pointer)LOG(ctx,1,local+17); /*log*/
	local[17]= w;
	ctx->vsp=local+18;
	w=(pointer)QUOTIENT(ctx,2,local+16); /*/*/
	local[16]= w;
	ctx->vsp=local+17;
	w=(pointer)CEILING(ctx,1,local+16); /*ceiling*/
	local[12] = w;
	local[16]= local[12];
IF405:
	local[16]= makeint((eusinteger_t)0L);
	local[17]= local[12];
WHL407:
	local[18]= local[16];
	w = local[17];
	if ((eusinteger_t)local[18] >= (eusinteger_t)w) goto WHX408;
	local[13] = NIL;
	local[18]= makeint((eusinteger_t)0L);
	local[19]= local[0];
WHL411:
	local[20]= local[18];
	w = local[19];
	if ((eusinteger_t)local[20] >= (eusinteger_t)w) goto WHX412;
	local[20]= local[7];
	ctx->vsp=local+21;
	w=(pointer)RANDOM(ctx,1,local+20); /*random*/
	local[8] = w;
WHL414:
	local[20]= local[8];
	local[21]= local[13];
	ctx->vsp=local+22;
	w=(*ftab[24])(ctx,2,local+20,&ftab[24],fqv[37]); /*find*/
	if (w==NIL) goto WHX415;
	local[20]= local[7];
	ctx->vsp=local+21;
	w=(pointer)RANDOM(ctx,1,local+20); /*random*/
	local[8] = w;
	goto WHL414;
WHX415:
	local[20]= NIL;
BLK416:
	local[20]= local[8];
	w = local[13];
	ctx->vsp=local+21;
	local[13] = cons(ctx,local[20],w);
	local[20]= local[18];
	ctx->vsp=local+21;
	w=(pointer)ADD1(ctx,1,local+20); /*1+*/
	local[18] = w;
	goto WHL411;
WHX412:
	local[20]= NIL;
BLK413:
	w = NIL;
	local[18]= local[13];
	w = local[14];
	ctx->vsp=local+19;
	local[14] = cons(ctx,local[18],w);
	local[18]= local[16];
	ctx->vsp=local+19;
	w=(pointer)ADD1(ctx,1,local+18); /*1+*/
	local[16] = w;
	goto WHL407;
WHX408:
	local[18]= NIL;
BLK409:
	w = NIL;
	local[16]= NIL;
	local[17]= local[14];
WHL418:
	if (local[17]==NIL) goto WHX419;
	w=local[17];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[18]= (w)->c.cons.car;
	w=local[17];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[17] = (w)->c.cons.cdr;
	w = local[18];
	local[16] = w;
	local[15] = NIL;
	local[18]= NIL;
	local[19]= local[16];
WHL423:
	if (local[19]==NIL) goto WHX424;
	w=local[19];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[20]= (w)->c.cons.car;
	w=local[19];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[19] = (w)->c.cons.cdr;
	w = local[20];
	local[18] = w;
	local[20]= argv[0];
	local[21]= local[18];
	ctx->vsp=local+22;
	w=(pointer)ELT(ctx,2,local+20); /*elt*/
	local[20]= w;
	w = local[15];
	ctx->vsp=local+21;
	local[15] = cons(ctx,local[20],w);
	goto WHL423;
WHX424:
	local[20]= NIL;
BLK425:
	w = NIL;
	local[18]= local[4];
	local[19]= local[15];
	ctx->vsp=local+20;
	w=(pointer)FUNCALL(ctx,2,local+18); /*funcall*/
	local[9] = w;
	local[18]= local[9];
	w = local[10];
	ctx->vsp=local+19;
	local[10] = cons(ctx,local[18],w);
	if (local[3]==NIL) goto IF427;
	local[18]= local[5];
	local[19]= local[9];
	local[20]= argv[0];
	local[21]= local[3];
	local[22]= fqv[38];
	local[23]= local[6];
	ctx->vsp=local+24;
	w=(pointer)FUNCALL(ctx,6,local+18); /*funcall*/
	local[18]= w;
	w = local[11];
	ctx->vsp=local+19;
	local[11] = cons(ctx,local[18],w);
	local[18]= local[11];
	goto IF428;
IF427:
	local[18]= local[5];
	local[19]= local[9];
	local[20]= argv[0];
	local[21]= fqv[38];
	local[22]= local[6];
	ctx->vsp=local+23;
	w=(pointer)FUNCALL(ctx,5,local+18); /*funcall*/
	local[18]= w;
	w = local[11];
	ctx->vsp=local+19;
	local[11] = cons(ctx,local[18],w);
	local[18]= local[11];
IF428:
	goto WHL418;
WHX419:
	local[18]= NIL;
BLK420:
	w = NIL;
	local[16]= local[10];
	local[17]= local[11];
	ctx->vsp=local+18;
	local[18]= makeclosure(codevec,quotevec,CLO429,env,argv,local);
	if (local[3]==NIL) goto IF430;
	local[19]= (pointer)get_sym_func(fqv[39]);
	goto IF431;
IF430:
	local[19]= (pointer)get_sym_func(fqv[40]);
IF431:
	ctx->vsp=local+20;
	w=(*ftab[25])(ctx,3,local+17,&ftab[25],fqv[41]); /*find-extream*/
	local[17]= w;
	local[18]= local[11];
	ctx->vsp=local+19;
	w=(*ftab[26])(ctx,2,local+17,&ftab[26],fqv[42]); /*position*/
	local[17]= w;
	ctx->vsp=local+18;
	w=(pointer)ELT(ctx,2,local+16); /*elt*/
	local[0]= w;
BLK396:
	ctx->vsp=local; return(local[0]);}

/*closure or cleaner*/
static pointer CLO429(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	w = argv[0];
	local[0]= w;
	ctx->vsp=local; return(local[0]);}

/*lmeds-error*/
static pointer F95lmeds_error(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<2) maerror();
	ctx->vsp=local+0;
	n=parsekeyparams(fqv[43], &argv[2], n-2, local+0, 0);
	if (n & (1<<0)) goto KEY433;
	local[0] = (pointer)get_sym_func(fqv[35]);
KEY433:
	local[1]= NIL;
	local[2]= NIL;
	local[3]= NIL;
	local[4]= argv[1];
WHL435:
	if (local[4]==NIL) goto WHX436;
	w=local[4];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[5]= (w)->c.cons.car;
	w=local[4];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[4] = (w)->c.cons.cdr;
	w = local[5];
	local[3] = w;
	local[5]= local[0];
	local[6]= argv[0];
	local[7]= local[3];
	ctx->vsp=local+8;
	w=(pointer)FUNCALL(ctx,3,local+5); /*funcall*/
	local[1] = w;
	local[5]= local[1];
	local[6]= local[1];
	ctx->vsp=local+7;
	w=(pointer)TIMES(ctx,2,local+5); /***/
	local[5]= w;
	w = local[2];
	ctx->vsp=local+6;
	local[2] = cons(ctx,local[5],w);
	goto WHL435;
WHX436:
	local[5]= NIL;
BLK437:
	w = NIL;
	local[3]= local[2];
	local[4]= (pointer)get_sym_func(fqv[40]);
	ctx->vsp=local+5;
	w=(pointer)SORT(ctx,2,local+3); /*sort*/
	local[3]= w;
	local[4]= local[2];
	ctx->vsp=local+5;
	w=(pointer)LENGTH(ctx,1,local+4); /*length*/
	local[4]= w;
	local[5]= makeint((eusinteger_t)2L);
	ctx->vsp=local+6;
	w=(pointer)QUOTIENT(ctx,2,local+4); /*/*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)ELT(ctx,2,local+3); /*elt*/
	local[0]= w;
BLK432:
	ctx->vsp=local; return(local[0]);}

/*lmeds-error-mat*/
static pointer F96lmeds_error_mat(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<2) maerror();
	ctx->vsp=local+0;
	n=parsekeyparams(fqv[44], &argv[2], n-2, local+0, 0);
	if (n & (1<<0)) goto KEY440;
	local[0] = (pointer)get_sym_func(fqv[35]);
KEY440:
	local[1]= argv[1];
	local[2]= makeint((eusinteger_t)0L);
	ctx->vsp=local+3;
	w=(*ftab[0])(ctx,2,local+1,&ftab[0],fqv[0]); /*array-dimension*/
	local[1]= w;
	local[2]= makeint((eusinteger_t)0L);
	local[3]= makeint((eusinteger_t)0L);
	local[4]= makeint((eusinteger_t)0L);
	ctx->vsp=local+5;
	w=(pointer)MKFLTVEC(ctx,3,local+2); /*float-vector*/
	local[2]= w;
	local[3]= NIL;
	local[4]= NIL;
	local[5]= makeint((eusinteger_t)0L);
	local[6]= local[1];
WHL442:
	local[7]= local[5];
	w = local[6];
	if ((eusinteger_t)local[7] >= (eusinteger_t)w) goto WHX443;
	local[7]= argv[1];
	local[8]= local[5];
	local[9]= local[2];
	ctx->vsp=local+10;
	w=(*ftab[27])(ctx,3,local+7,&ftab[27],fqv[45]); /*c-matrix-row*/
	local[7]= local[0];
	local[8]= argv[0];
	local[9]= local[2];
	ctx->vsp=local+10;
	w=(pointer)FUNCALL(ctx,3,local+7); /*funcall*/
	local[3] = w;
	local[7]= local[3];
	local[8]= local[3];
	ctx->vsp=local+9;
	w=(pointer)TIMES(ctx,2,local+7); /***/
	local[7]= w;
	w = local[4];
	ctx->vsp=local+8;
	local[4] = cons(ctx,local[7],w);
	local[7]= local[5];
	ctx->vsp=local+8;
	w=(pointer)ADD1(ctx,1,local+7); /*1+*/
	local[5] = w;
	goto WHL442;
WHX443:
	local[7]= NIL;
BLK444:
	w = NIL;
	local[5]= local[4];
	local[6]= (pointer)get_sym_func(fqv[40]);
	ctx->vsp=local+7;
	w=(pointer)SORT(ctx,2,local+5); /*sort*/
	local[5]= w;
	local[6]= local[4];
	ctx->vsp=local+7;
	w=(pointer)LENGTH(ctx,1,local+6); /*length*/
	local[6]= w;
	local[7]= makeint((eusinteger_t)2L);
	ctx->vsp=local+8;
	w=(pointer)QUOTIENT(ctx,2,local+6); /*/*/
	local[6]= w;
	ctx->vsp=local+7;
	w=(pointer)ELT(ctx,2,local+5); /*elt*/
	local[0]= w;
BLK439:
	ctx->vsp=local; return(local[0]);}

/*concatenate-matrix-column*/
static pointer F97concatenate_matrix_column(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<0) maerror();
RST446:
	ctx->vsp=local+0;
	local[0]= minilist(ctx,&argv[n],n-0);
	local[1]= NIL;
	local[2]= NIL;
	w=local[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[3]= (w)->c.cons.car;
	local[4]= makeint((eusinteger_t)1L);
	ctx->vsp=local+5;
	w=(*ftab[0])(ctx,2,local+3,&ftab[0],fqv[0]); /*array-dimension*/
	local[3]= w;
	local[4]= NIL;
	local[5]= local[0];
WHL448:
	if (local[5]==NIL) goto WHX449;
	w=local[5];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[6]= (w)->c.cons.car;
	w=local[5];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[5] = (w)->c.cons.cdr;
	w = local[6];
	local[4] = w;
	local[6]= local[4];
	local[7]= makeint((eusinteger_t)1L);
	ctx->vsp=local+8;
	w=(*ftab[0])(ctx,2,local+6,&ftab[0],fqv[0]); /*array-dimension*/
	local[6]= w;
	local[7]= local[3];
	ctx->vsp=local+8;
	w=(pointer)NUMEQUAL(ctx,2,local+6); /*=*/
	if (w!=NIL) goto IF452;
	local[6]= fqv[46];
	ctx->vsp=local+7;
	local[7]= makeclosure(codevec,quotevec,CLO454,env,argv,local);
	local[8]= local[0];
	ctx->vsp=local+9;
	w=(pointer)MAPCAR(ctx,2,local+7); /*mapcar*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(pointer)SIGERROR(ctx,2,local+6); /*error*/
	local[6]= w;
	goto IF453;
IF452:
	local[6]= NIL;
IF453:
	if (local[4]==NIL) goto IF455;
	local[6]= local[4];
	local[7]= makeint((eusinteger_t)0L);
	ctx->vsp=local+8;
	w=(*ftab[19])(ctx,2,local+6,&ftab[19],fqv[27]); /*matrix-column*/
	local[6]= w;
	ctx->vsp=local+7;
	w=(pointer)LENGTH(ctx,1,local+6); /*length*/
	local[6]= w;
	goto IF456;
IF455:
	local[6]= makeint((eusinteger_t)0L);
IF456:
	local[1] = local[6];
	local[6]= makeint((eusinteger_t)0L);
	local[7]= local[1];
WHL458:
	local[8]= local[6];
	w = local[7];
	if ((eusinteger_t)local[8] >= (eusinteger_t)w) goto WHX459;
	local[8]= local[4];
	local[9]= local[6];
	ctx->vsp=local+10;
	w=(*ftab[28])(ctx,2,local+8,&ftab[28],fqv[47]); /*matrix-row*/
	local[8]= w;
	w = local[2];
	ctx->vsp=local+9;
	local[2] = cons(ctx,local[8],w);
	local[8]= local[6];
	ctx->vsp=local+9;
	w=(pointer)ADD1(ctx,1,local+8); /*1+*/
	local[6] = w;
	goto WHL458;
WHX459:
	local[8]= NIL;
BLK460:
	w = NIL;
	goto WHL448;
WHX449:
	local[6]= NIL;
BLK450:
	w = NIL;
	if (local[2]==NIL) goto IF461;
	local[4]= (pointer)get_sym_func(fqv[48]);
	local[5]= local[2];
	ctx->vsp=local+6;
	w=(pointer)REVERSE(ctx,1,local+5); /*reverse*/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)APPLY(ctx,2,local+4); /*apply*/
	local[4]= w;
	goto IF462;
IF461:
	local[4]= NIL;
IF462:
	w = local[4];
	local[0]= w;
BLK445:
	ctx->vsp=local; return(local[0]);}

/*closure or cleaner*/
static pointer CLO454(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	local[0]= argv[0];
	local[1]= makeint((eusinteger_t)1L);
	ctx->vsp=local+2;
	w=(*ftab[0])(ctx,2,local+0,&ftab[0],fqv[0]); /*array-dimension*/
	local[0]= w;
	ctx->vsp=local; return(local[0]);}

/*concatenate-matrix-row*/
static pointer F98concatenate_matrix_row(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<0) maerror();
RST464:
	ctx->vsp=local+0;
	local[0]= minilist(ctx,&argv[n],n-0);
	local[1]= NIL;
	local[2]= NIL;
	w=local[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[3]= (w)->c.cons.car;
	local[4]= makeint((eusinteger_t)0L);
	ctx->vsp=local+5;
	w=(*ftab[0])(ctx,2,local+3,&ftab[0],fqv[0]); /*array-dimension*/
	local[3]= w;
	local[4]= NIL;
	local[5]= local[0];
WHL466:
	if (local[5]==NIL) goto WHX467;
	w=local[5];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[6]= (w)->c.cons.car;
	w=local[5];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[5] = (w)->c.cons.cdr;
	w = local[6];
	local[4] = w;
	local[6]= local[4];
	local[7]= makeint((eusinteger_t)0L);
	ctx->vsp=local+8;
	w=(*ftab[0])(ctx,2,local+6,&ftab[0],fqv[0]); /*array-dimension*/
	local[6]= w;
	local[7]= local[3];
	ctx->vsp=local+8;
	w=(pointer)NUMEQUAL(ctx,2,local+6); /*=*/
	if (w!=NIL) goto IF470;
	local[6]= fqv[49];
	ctx->vsp=local+7;
	local[7]= makeclosure(codevec,quotevec,CLO472,env,argv,local);
	local[8]= local[0];
	ctx->vsp=local+9;
	w=(pointer)MAPCAR(ctx,2,local+7); /*mapcar*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(pointer)SIGERROR(ctx,2,local+6); /*error*/
	local[6]= w;
	goto IF471;
IF470:
	local[6]= NIL;
IF471:
	if (local[4]==NIL) goto IF473;
	local[6]= local[4];
	local[7]= makeint((eusinteger_t)0L);
	ctx->vsp=local+8;
	w=(*ftab[28])(ctx,2,local+6,&ftab[28],fqv[47]); /*matrix-row*/
	local[6]= w;
	ctx->vsp=local+7;
	w=(pointer)LENGTH(ctx,1,local+6); /*length*/
	local[6]= w;
	goto IF474;
IF473:
	local[6]= makeint((eusinteger_t)0L);
IF474:
	local[1] = local[6];
	local[6]= makeint((eusinteger_t)0L);
	local[7]= local[1];
WHL476:
	local[8]= local[6];
	w = local[7];
	if ((eusinteger_t)local[8] >= (eusinteger_t)w) goto WHX477;
	local[8]= local[4];
	local[9]= local[6];
	ctx->vsp=local+10;
	w=(*ftab[19])(ctx,2,local+8,&ftab[19],fqv[27]); /*matrix-column*/
	local[8]= w;
	w = local[2];
	ctx->vsp=local+9;
	local[2] = cons(ctx,local[8],w);
	local[8]= local[6];
	ctx->vsp=local+9;
	w=(pointer)ADD1(ctx,1,local+8); /*1+*/
	local[6] = w;
	goto WHL476;
WHX477:
	local[8]= NIL;
BLK478:
	w = NIL;
	goto WHL466;
WHX467:
	local[6]= NIL;
BLK468:
	w = NIL;
	if (local[2]==NIL) goto IF479;
	local[4]= (pointer)get_sym_func(fqv[48]);
	local[5]= local[2];
	ctx->vsp=local+6;
	w=(pointer)REVERSE(ctx,1,local+5); /*reverse*/
	local[5]= w;
	ctx->vsp=local+6;
	w=(pointer)APPLY(ctx,2,local+4); /*apply*/
	local[4]= w;
	ctx->vsp=local+5;
	w=(pointer)TRANSPOSE(ctx,1,local+4); /*transpose*/
	local[4]= w;
	goto IF480;
IF479:
	local[4]= NIL;
IF480:
	w = local[4];
	local[0]= w;
BLK463:
	ctx->vsp=local; return(local[0]);}

/*closure or cleaner*/
static pointer CLO472(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	local[0]= argv[0];
	local[1]= makeint((eusinteger_t)0L);
	ctx->vsp=local+2;
	w=(*ftab[0])(ctx,2,local+0,&ftab[0],fqv[0]); /*array-dimension*/
	local[0]= w;
	ctx->vsp=local; return(local[0]);}

/*concatenate-matrix-diagonal*/
static pointer F99concatenate_matrix_diagonal(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<0) maerror();
RST482:
	ctx->vsp=local+0;
	local[0]= minilist(ctx,&argv[n],n-0);
	local[1]= NIL;
	local[2]= NIL;
	local[3]= NIL;
	local[4]= NIL;
	local[5]= NIL;
	local[6]= NIL;
	local[7]= local[0];
WHL484:
	if (local[7]==NIL) goto WHX485;
	w=local[7];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[8]= (w)->c.cons.car;
	w=local[7];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[7] = (w)->c.cons.cdr;
	w = local[8];
	local[6] = w;
	if (local[6]==NIL) goto IF488;
	local[8]= local[6];
	local[9]= makeint((eusinteger_t)0L);
	ctx->vsp=local+10;
	w=(*ftab[28])(ctx,2,local+8,&ftab[28],fqv[47]); /*matrix-row*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)LENGTH(ctx,1,local+8); /*length*/
	local[8]= w;
	goto IF489;
IF488:
	local[8]= makeint((eusinteger_t)0L);
IF489:
	w = local[3];
	ctx->vsp=local+9;
	local[3] = cons(ctx,local[8],w);
	goto WHL484;
WHX485:
	local[8]= NIL;
BLK486:
	w = NIL;
	local[6]= local[3];
	ctx->vsp=local+7;
	w=(pointer)REVERSE(ctx,1,local+6); /*reverse*/
	local[3] = w;
	local[6]= makeint((eusinteger_t)0L);
	local[7]= local[0];
	ctx->vsp=local+8;
	w=(pointer)LENGTH(ctx,1,local+7); /*length*/
	local[7]= w;
WHL491:
	local[8]= local[6];
	w = local[7];
	if ((eusinteger_t)local[8] >= (eusinteger_t)w) goto WHX492;
	local[8]= local[6];
	local[9]= local[0];
	ctx->vsp=local+10;
	w=(pointer)NTH(ctx,2,local+8); /*nth*/
	local[1] = w;
	if (local[1]==NIL) goto IF494;
	local[8]= local[1];
	local[9]= makeint((eusinteger_t)0L);
	ctx->vsp=local+10;
	w=(*ftab[19])(ctx,2,local+8,&ftab[19],fqv[27]); /*matrix-column*/
	local[8]= w;
	ctx->vsp=local+9;
	w=(pointer)LENGTH(ctx,1,local+8); /*length*/
	local[8]= w;
	goto IF495;
IF494:
	local[8]= makeint((eusinteger_t)0L);
IF495:
	local[2] = local[8];
	local[8]= makeint((eusinteger_t)0L);
	local[9]= local[2];
WHL497:
	local[10]= local[8];
	w = local[9];
	if ((eusinteger_t)local[10] >= (eusinteger_t)w) goto WHX498;
	local[5] = NIL;
	local[10]= makeint((eusinteger_t)0L);
	local[11]= local[3];
	ctx->vsp=local+12;
	w=(pointer)LENGTH(ctx,1,local+11); /*length*/
	local[11]= w;
WHL501:
	local[12]= local[10];
	w = local[11];
	if ((eusinteger_t)local[12] >= (eusinteger_t)w) goto WHX502;
	local[12]= local[6];
	if (local[10]!=local[12]) goto IF504;
	local[12]= local[1];
	local[13]= local[8];
	ctx->vsp=local+14;
	w=(*ftab[28])(ctx,2,local+12,&ftab[28],fqv[47]); /*matrix-row*/
	local[12]= w;
	w = local[5];
	ctx->vsp=local+13;
	local[5] = cons(ctx,local[12],w);
	local[12]= local[5];
	goto IF505;
IF504:
	local[12]= local[10];
	local[13]= local[3];
	ctx->vsp=local+14;
	w=(pointer)NTH(ctx,2,local+12); /*nth*/
	local[12]= w;
	local[13]= fqv[50];
	local[14]= loadglobal(fqv[4]);
	local[15]= fqv[22];
	local[16]= makeint((eusinteger_t)0L);
	ctx->vsp=local+17;
	w=(*ftab[29])(ctx,5,local+12,&ftab[29],fqv[51]); /*make-array*/
	local[12]= w;
	w = local[5];
	ctx->vsp=local+13;
	local[5] = cons(ctx,local[12],w);
	local[12]= local[5];
IF505:
	local[12]= local[10];
	ctx->vsp=local+13;
	w=(pointer)ADD1(ctx,1,local+12); /*1+*/
	local[10] = w;
	goto WHL501;
WHX502:
	local[12]= NIL;
BLK503:
	w = NIL;
	local[10]= (pointer)get_sym_func(fqv[52]);
	local[11]= loadglobal(fqv[4]);
	local[12]= local[5];
	ctx->vsp=local+13;
	w=(pointer)REVERSE(ctx,1,local+12); /*reverse*/
	ctx->vsp=local+12;
	local[11]= cons(ctx,local[11],w);
	ctx->vsp=local+12;
	w=(pointer)APPLY(ctx,2,local+10); /*apply*/
	local[10]= w;
	w = local[4];
	ctx->vsp=local+11;
	local[4] = cons(ctx,local[10],w);
	local[10]= local[8];
	ctx->vsp=local+11;
	w=(pointer)ADD1(ctx,1,local+10); /*1+*/
	local[8] = w;
	goto WHL497;
WHX498:
	local[10]= NIL;
BLK499:
	w = NIL;
	local[8]= local[6];
	ctx->vsp=local+9;
	w=(pointer)ADD1(ctx,1,local+8); /*1+*/
	local[6] = w;
	goto WHL491;
WHX492:
	local[8]= NIL;
BLK493:
	w = NIL;
	if (local[4]==NIL) goto IF506;
	local[6]= (pointer)get_sym_func(fqv[48]);
	local[7]= local[4];
	ctx->vsp=local+8;
	w=(pointer)REVERSE(ctx,1,local+7); /*reverse*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(pointer)APPLY(ctx,2,local+6); /*apply*/
	local[6]= w;
	goto IF507;
IF506:
	local[6]= NIL;
IF507:
	w = local[6];
	local[0]= w;
BLK481:
	ctx->vsp=local; return(local[0]);}

/*vector-variance*/
static pointer F100vector_variance(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	local[0]= argv[0];
	ctx->vsp=local+1;
	w=(pointer)LENGTH(ctx,1,local+0); /*length*/
	local[0]= w;
	local[1]= local[0];
	w=argv[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[2]= (w)->c.cons.car;
	ctx->vsp=local+3;
	w=(pointer)LENGTH(ctx,1,local+2); /*length*/
	local[2]= w;
	local[3]= argv[0];
	ctx->vsp=local+4;
	w=(*ftab[3])(ctx,3,local+1,&ftab[3],fqv[3]); /*make-matrix*/
	local[1]= w;
	local[2]= loadglobal(fqv[4]);
	w=argv[0];
	if (!iscons(w) && w!=NIL) error(E_NOLIST);
	local[3]= (w)->c.cons.car;
	ctx->vsp=local+4;
	w=(pointer)LENGTH(ctx,1,local+3); /*length*/
	local[3]= w;
	ctx->vsp=local+4;
	w=(pointer)INSTANTIATE(ctx,2,local+2); /*instantiate*/
	local[2]= w;
	local[3]= makeint((eusinteger_t)0L);
	local[4]= local[2];
	ctx->vsp=local+5;
	w=(pointer)LENGTH(ctx,1,local+4); /*length*/
	local[4]= w;
WHL510:
	local[5]= local[3];
	w = local[4];
	if ((eusinteger_t)local[5] >= (eusinteger_t)w) goto WHX511;
	local[5]= local[2];
	local[6]= local[3];
	local[7]= local[1];
	local[8]= local[3];
	ctx->vsp=local+9;
	w=(*ftab[19])(ctx,2,local+7,&ftab[19],fqv[27]); /*matrix-column*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(*ftab[30])(ctx,1,local+7,&ftab[30],fqv[53]); /*variance*/
	local[7]= w;
	ctx->vsp=local+8;
	w=(pointer)SETELT(ctx,3,local+5); /*setelt*/
	local[5]= local[3];
	ctx->vsp=local+6;
	w=(pointer)ADD1(ctx,1,local+5); /*1+*/
	local[3] = w;
	goto WHL510;
WHX511:
	local[5]= NIL;
BLK512:
	w = NIL;
	w = local[2];
	local[0]= w;
BLK508:
	ctx->vsp=local; return(local[0]);}

/*covariance-matrix*/
static pointer F101covariance_matrix(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n!=1) maerror();
	local[0]= NIL;
	local[1]= NIL;
	local[2]= argv[0];
	ctx->vsp=local+3;
	w=(pointer)LENGTH(ctx,1,local+2); /*length*/
	local[1] = w;
	local[2]= local[1];
	local[3]= local[1];
	ctx->vsp=local+4;
	w=(*ftab[3])(ctx,2,local+2,&ftab[3],fqv[3]); /*make-matrix*/
	local[0] = w;
	local[2]= makeint((eusinteger_t)0L);
	local[3]= local[1];
WHL515:
	local[4]= local[2];
	w = local[3];
	if ((eusinteger_t)local[4] >= (eusinteger_t)w) goto WHX516;
	local[4]= makeint((eusinteger_t)0L);
	local[5]= local[1];
WHL519:
	local[6]= local[4];
	w = local[5];
	if ((eusinteger_t)local[6] >= (eusinteger_t)w) goto WHX520;
	local[6]= local[0];
	local[7]= local[2];
	local[8]= local[4];
	local[9]= argv[0];
	local[10]= local[2];
	ctx->vsp=local+11;
	w=(pointer)ELT(ctx,2,local+9); /*elt*/
	local[9]= w;
	local[10]= argv[0];
	local[11]= local[4];
	ctx->vsp=local+12;
	w=(pointer)ELT(ctx,2,local+10); /*elt*/
	local[10]= w;
	ctx->vsp=local+11;
	w=(*ftab[31])(ctx,2,local+9,&ftab[31],fqv[54]); /*covariance*/
	local[9]= w;
	ctx->vsp=local+10;
	w=(pointer)ASET(ctx,4,local+6); /*aset*/
	local[6]= local[4];
	ctx->vsp=local+7;
	w=(pointer)ADD1(ctx,1,local+6); /*1+*/
	local[4] = w;
	goto WHL519;
WHX520:
	local[6]= NIL;
BLK521:
	w = NIL;
	local[4]= local[2];
	ctx->vsp=local+5;
	w=(pointer)ADD1(ctx,1,local+4); /*1+*/
	local[2] = w;
	goto WHL515;
WHX516:
	local[4]= NIL;
BLK517:
	w = local[0];
	local[0]= w;
BLK513:
	ctx->vsp=local; return(local[0]);}

/*normalize-vector*/
static pointer F102normalize_vector(ctx,n,argv,env)
register context *ctx;
register int n; register pointer argv[]; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv=qv;
  numunion nu;
	if (n<1) maerror();
	if (n>=2) { local[0]=(argv[1]); goto ENT525;}
	local[0]= NIL;
ENT525:
	if (n>=3) { local[1]=(argv[2]); goto ENT524;}
	local[1]= makeflt(9.9999999999999949376344e-21);
ENT524:
ENT523:
	if (n>3) maerror();
	local[2]= argv[0];
	ctx->vsp=local+3;
	w=(pointer)VNORM(ctx,1,local+2); /*norm*/
	local[2]= w;
	local[3]= local[1];
	ctx->vsp=local+4;
	w=(pointer)LESSP(ctx,2,local+2); /*<*/
	if (w==NIL) goto IF526;
	if (local[0]==NIL) goto IF528;
	local[2]= local[0];
	local[3]= makeint((eusinteger_t)0L);
	ctx->vsp=local+4;
	w=(*ftab[15])(ctx,2,local+2,&ftab[15],fqv[21]); /*fill*/
	local[2]= w;
	goto IF529;
IF528:
	local[2]= loadglobal(fqv[4]);
	local[3]= argv[0];
	ctx->vsp=local+4;
	w=(pointer)LENGTH(ctx,1,local+3); /*length*/
	local[3]= w;
	ctx->vsp=local+4;
	w=(pointer)INSTANTIATE(ctx,2,local+2); /*instantiate*/
	local[2]= w;
IF529:
	goto IF527;
IF526:
	if (local[0]==NIL) goto IF530;
	local[2]= argv[0];
	local[3]= local[0];
	ctx->vsp=local+4;
	w=(pointer)VNORMALIZE(ctx,2,local+2); /*normalize-vector-org*/
	local[2]= w;
	goto IF531;
IF530:
	local[2]= argv[0];
	ctx->vsp=local+3;
	w=(pointer)VNORMALIZE(ctx,1,local+2); /*normalize-vector-org*/
	local[2]= w;
IF531:
IF527:
	w = local[2];
	local[0]= w;
BLK522:
	ctx->vsp=local; return(local[0]);}

/* initializer*/
pointer ___irtmath(ctx,n,argv,env)
register context *ctx; int n; pointer *argv; pointer env;
{ register pointer *local=ctx->vsp, w, *fqv;
  register int i;
  numunion nu;
  module=argv[0];
  quotevec=build_quote_vector(ctx,QUOTE_STRINGS_SIZE, quote_strings);
  module->c.code.quotevec=quotevec;
  codevec=module->c.code.codevec;
  fqv=qv=quotevec->c.vec.v;
  init_ftab();
	ctx->vsp=local+0;
	compfun(ctx,fqv[55],module,F69inverse_matrix,fqv[56]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[57],module,F70inverse_matrix_complex,fqv[58]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[59],module,F71m__complex,fqv[60]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[61],module,F72diagonal,fqv[62]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[63],module,F73minor_matrix,fqv[64]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[65],module,F74atan2,fqv[66]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[67],module,F75outer_product_matrix,fqv[68]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[69],module,F76matrix2quaternion,fqv[70]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[71],module,F77quaternion2matrix,fqv[72]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[73],module,F78matrix_log,fqv[74]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[75],module,F79matrix_exponent,fqv[76]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[77],module,F80midrot,fqv[78]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[79],module,F81pseudo_inverse,fqv[80]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[81],module,F82pseudo_inverse_org,fqv[82]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[83],module,F83sr_inverse,fqv[84]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[85],module,F84sr_inverse_org,fqv[86]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[87],module,F85manipulability,fqv[88]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[89],module,F86random_gauss,fqv[90]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[91],module,F87gaussian_random,fqv[92]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[93],module,F88eigen_decompose,fqv[94]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[95],module,F89eigen_decompose_complex,fqv[96]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[97],module,F90solve_non_zero_vector_from_det0_matrix,fqv[98]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[33],module,F91lms,fqv[99]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[35],module,F92lms_estimate,fqv[100]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[101],module,F93lms_error,fqv[102]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[103],module,F94lmeds,fqv[104]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[34],module,F95lmeds_error,fqv[105]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[106],module,F96lmeds_error_mat,fqv[107]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[108],module,F97concatenate_matrix_column,fqv[109]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[110],module,F98concatenate_matrix_row,fqv[111]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[112],module,F99concatenate_matrix_diagonal,fqv[113]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[114],module,F100vector_variance,fqv[115]);
	ctx->vsp=local+0;
	compfun(ctx,fqv[116],module,F101covariance_matrix,fqv[117]);
	local[0]= fqv[118];
	ctx->vsp=local+1;
	w=(pointer)FBOUNDP(ctx,1,local+0); /*fboundp*/
	if (w!=NIL) goto IF532;
	local[0]= fqv[119];
	local[1]= fqv[120];
	ctx->vsp=local+2;
	w=(*ftab[32])(ctx,2,local+0,&ftab[32],fqv[121]); /*remprop*/
	local[0]= fqv[118];
	local[1]= fqv[119];
	ctx->vsp=local+2;
	w=(pointer)SYMFUNC(ctx,1,local+1); /*symbol-function*/
	local[1]= w;
	ctx->vsp=local+2;
	w=(pointer)SETFUNC(ctx,2,local+0); /*lisp::setfunc*/
	local[0]= fqv[118];
	local[1]= fqv[122];
	ctx->vsp=local+2;
	w=(*ftab[33])(ctx,2,local+0,&ftab[33],fqv[123]); /*compiler::def-builtin-entry*/
	local[0]= w;
	goto IF533;
IF532:
	local[0]= NIL;
IF533:
	ctx->vsp=local+0;
	compfun(ctx,fqv[119],module,F102normalize_vector,fqv[124]);
	local[0]= fqv[125];
	local[1]= fqv[126];
	ctx->vsp=local+2;
	w=(*ftab[34])(ctx,2,local+0,&ftab[34],fqv[127]); /*provide*/
	local[0]= NIL;
	ctx->vsp=local; return(local[0]);}
static void init_ftab()
{  register int i;
  for (i=0; i<35; i++) ftab[i]=fcallx;
}
